package pascal2cplusplus;

import java.io.FileInputStream;
import java.io.*;
import java.util.LinkedList;
import java.util.Iterator;

/**
 * <p>Title: Pascal2C++</p>
 * <p>Description: semestrln projekt (X36PJP+X36BPJ)</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class LexAnalyzator {

  public static final String[] KEYWORDS={
      "program",
      "unit",
      "interface",
      "uses",
      "label",
      "type",
      "record",
      "object",
      "private",
      "protected",
      "public",
      "virtual",
      "const",
      "var",
      "implementation",
      "begin",
      "end",
      "case",
      "if",
      "then",
      "else",
      "goto",
      "asm",
      "repeat",
      "until",
      "while",
      "do",
      "procedure",
      "function",
      "assembler",
      "for",
      "downto",
      "to",
      "of",
      "with"
  };

  public static final String[] OPERATORS={
      "+",
      "-",
      "*",
      "/",
      "and",
      "xor",
      "or",
      "not",
      "div",
      "shl",
      "shr",
      "mod",
      "in"
  };

  public static final String[] TYPES={
      "byte",
      "word",
      "shortint",
      "integer",
      "longint",
      "char",
      "string",
      "array",
      "boolean",
      "real",
      "single",
      "double",
      "extended",
      "comp",
      "pointer",
      "file",
      "text"
  };

  public static final String[] BOOL_VALUE={
      "true",
      "false"
  };

  public static final int CODE_NORMAL                      =  0;
  public static final int CODE_QUOTE                       =  1;
  public static final int CODE_ASM                         =  2;
  public static final int CODE_NOTE                        =  3;
  public static final int CODE_SPACE                       =  4;

  public static final int CODE_NM_INT_DEC                  =  5;
  public static final int CODE_NM_INT_HEX                  =  6;
  public static final int CODE_NM_FLOAT                    =  7;
  public static final int CODE_NM_BOOL                     =  8;
  public static final int CODE_NM_CHAR                     =  9;

  public static final int CODE_IS_EQUAL_TO                 = 10;
  public static final int CODE_IS_NOT_EQUAL_TO             = 11;
  public static final int CODE_IS_LESS_THAN                = 12;
  public static final int CODE_IS_GREATER_THAN             = 13;
  public static final int CODE_IS_LESS_THAN_OR_EQUAL_TO    = 14;
  public static final int CODE_IS_GREATER_THAN_OR_EQUAL_TO = 15;

  public static final int CODE_IDENT                       = 16;

  public int lastNoteSymbol                                =  0;
  public int quoteCount                                    =  0;
  public int codeStatus=CODE_NORMAL;

  public static int blockCount                             =  0;

  public int status                                        =  0;

  private int lineCount                                    =  1;

  LinkedList list=new LinkedList();

  public static LinkedList done=new LinkedList();
  public static LinkedList runned=new LinkedList();
  public static LinkedList translated=new LinkedList();

  public LexAnalyzator(String filename) {
    filename=filename.toLowerCase();
    System.out.println(">Pekldn> soubor " + filename);
    for (Iterator i=runned.iterator();i.hasNext();)
      if (filename.equals (((LEX_ident) i.next()).code.toString()+".pas")) return;
    StringBuffer name=new StringBuffer();
    runned.add(new LEX_ident(name.append(filename)));

    FileInputStream fi=null;
    try {
      fi = new FileInputStream(filename);
    }
    catch (FileNotFoundException ex) {
      System.out.println(">Chyba> Soubor "+filename+" nenalezen...");
      return;
    }

    char data;
    StringBuffer elem=new StringBuffer(); //slouzi k docasnemu ulozeni delsich LEX
    try {
      while ( (data = (char) fi.read()) != (char) -1) {
        boolean next=true;

        if (codeStatus==CODE_QUOTE) { // Pokud ctu String ""
          if (data!='\'') {
            if ((quoteCount&1)==1) {
              list.add(new LEX_string(elem));
              elem=new StringBuffer();
              codeStatus=CODE_NORMAL;
            } else {
              elem.append(data);
              quoteCount=0;
              next=false;
            }
          } else {
            quoteCount++;
            elem.append(data);
            next=false;
          }
        }
        if (!next) continue;

        if (codeStatus==CODE_IDENT) { //ctu-li identifikator
          if (((data >= 'a') && (data <= 'z')) ||
              ((data >= 'A') && (data <= 'Z')) ||
              ((data >= '0') && (data <= '9')) ||
              (data == '_')
             ) {
            elem.append(data);
            next=false;
          } else {
            elem.replace(0, elem.length(), elem.toString().toLowerCase());
            int out = -1;
            for (int i = 0; i < KEYWORDS.length; i++)
              if (KEYWORDS[i].equals(elem.toString()))
                out = i;
            if (out == -1) {
              for (int i = 0; i < OPERATORS.length; i++)
                if (OPERATORS[i].equals(elem.toString()))
                  out = i;
              if (out==-1) {
                for (int i = 0; i < TYPES.length; i++)
                  if (TYPES[i].equals(elem.toString()))
                    out = i;
                if (out == -1) {
                  for (int i = 0; i < BOOL_VALUE.length; i++)
                    if (BOOL_VALUE[i].equals(elem.toString()))
                      out = i;
                  if (out == -1) {
                    list.add(new LEX_ident(elem));
                  } else list.add(new LEX_number(elem,CODE_NM_BOOL));
                } else list.add(new LEX_type(elem));
              } else list.add(new LEX_operator(elem));
            }
            else {
              list.add(new LEX_keyword(elem, out));
              //if ("asm".equals(elem.toString())) codeStatus=CODE_ASM;
            }
            elem = new StringBuffer();
            //elem.append(data);
            if (codeStatus!=CODE_ASM) codeStatus = CODE_NORMAL;
          }
        }

       if (codeStatus==CODE_NM_INT_DEC) { //prozatim ctu cele cislo (muze prejit na des.)
         switch (data) {
           case '0': case '1': case '2': case '3': case '4': case'5':
           case '6': case '7': case '8': case '9':
             elem.append(data);
             next=false;
             break;
           case '.': case 'E': case 'e':
             elem.append(data);
             next=false;
             codeStatus=CODE_NM_FLOAT;
             break;
           default:
             list.add(new LEX_number(elem,CODE_NM_INT_DEC));
             elem=new StringBuffer();
             codeStatus=CODE_NORMAL;
         }
       }
       if (!next) continue;
       if (codeStatus==CODE_NM_CHAR) { //ctu-li char #45
         switch (data) {
           case '0': case '1': case '2': case '3': case '4': case'5':
           case '6': case '7': case '8': case '9':
             elem.append(data);
             next=false;
             break;
           default:
             list.add(new LEX_number(elem,CODE_NM_CHAR));
             elem=new StringBuffer();
             codeStatus=CODE_NORMAL;
         }
       }
       if (!next) continue;
       if (codeStatus==CODE_NM_INT_HEX) {// ctu-li hex. cislo $45F
         switch (data) {
           case '0': case '1': case '2': case '3': case '4': case '5':
           case '6': case '7': case '8': case '9': case 'a': case 'b':
           case 'c': case 'd': case 'e': case 'f': case 'A': case 'B':
           case 'C': case 'D': case 'E': case 'F':
             elem.append(data);
             break;
           default:
             list.add(new LEX_number(elem,CODE_NM_INT_HEX));
             elem=new StringBuffer();
             codeStatus=CODE_NORMAL;
         }
       }
       if (!next) continue;
       if (codeStatus==CODE_NM_FLOAT) {//ctu-li des. cislo
         switch (data) {
           case '0': case '1': case '2': case '3': case '4': case '5':
           case '6': case '7': case '8': case '9': case 'e': case 'E':
             next=false;
             elem.append(data);
             break;
           case '.':
             elem.deleteCharAt(elem.length()-1);
             if (elem.charAt(0)=='$') {
               list.add(new LEX_number(elem, CODE_NM_INT_HEX));
             } else list.add(new LEX_number(elem, CODE_NM_INT_DEC));
             elem=new StringBuffer();
             elem.append("..");
             list.add(new LEX_to(elem));
             elem=new StringBuffer();
             codeStatus=CODE_NORMAL;
             next=false;
             break;
           case '+': case '-':
             switch (elem.charAt(elem.length()-1)) {
               case 'e': case 'E':
                 elem.append(data);
                 next=false;
                 break;
               default:
                 list.add(new LEX_number(elem,CODE_NM_FLOAT));
                 elem=new StringBuffer();
                 codeStatus=CODE_NORMAL;
             }
             break;
           default:
             list.add(new LEX_number(elem,CODE_NM_FLOAT));
             elem=new StringBuffer();
             codeStatus=CODE_NORMAL;
         }
       }


       if (!next) continue;
        if (codeStatus==CODE_SPACE) { //ctu-li mezery, tabulatory ci entery
            switch (data) {
              case 0x0A:
                lineCount++;
              case '\t': case 0x0D: case ' ':
                elem.append(data);
                next=false;
                break;
              default:
                //System.out.println(data+"-"+((int)data));
                list.add(new LEX_space(elem));
                elem=new StringBuffer();
                //System.out.println(elem.length());
                codeStatus=CODE_NORMAL;
            }
        }
        if (!next) continue;
        switch (codeStatus) {
          case CODE_NORMAL: // ctu-li zatim nespecifikovanou cast textu
            switch (data) {
                case '.':
                  if (elem.length()>0) {
                    if (".".equals(elem.toString())) {
                      list.add(new LEX_to(elem.append(data)));
                      elem=new StringBuffer();
                    } else {
                      LEXdecode(elem);
                      elem=new StringBuffer();
                      elem.append(data);
                    }
                  } else {
                    elem.append(data);
                  }
                  break;
                case '\'':
                  LEXdecode(elem);
                  elem=new StringBuffer();
                  elem.append(data);
                  codeStatus=CODE_QUOTE;
                  quoteCount=0;
                  break;
                case ';':
                  LEXdecode(elem);
                  elem=new StringBuffer();
                  list.add(new LEX_semicolon(elem.append(data)));
                  elem=new StringBuffer();
                  break;
                case '*':
                  if (elem.toString().equals("(")) {
                    codeStatus = CODE_NOTE;
                    elem.append(data);
                    lastNoteSymbol=1;
                  } else {
                    LEXdecode(elem);
                    elem=new StringBuffer();
                    list.add(new LEX_operator(elem.append(data)));
                    elem=new StringBuffer();
                  }
                  break;
                case '>':
                  if ("<".equals(elem.toString())) {
                    list.add(new LEX_relation(elem.append(data),CODE_IS_NOT_EQUAL_TO));
                    elem=new StringBuffer();
                  } else elem.append(data);
                  break;
                case '{':
                  LEXdecode(elem);
                  codeStatus = CODE_NOTE;
                  elem.append(data);
                  lastNoteSymbol=2;
                  break;
                case '+': case '-': case '/':
                  LEXdecode(elem);
                  elem=new StringBuffer();
                  list.add(new LEX_operator(elem.append(data)));
                  elem=new StringBuffer();
                  break;
                case '[':
                  LEXdecode(elem);
                  elem=new StringBuffer();
                  list.add(new LEX_openSquareBracket(elem.append(data)));
                  elem=new StringBuffer();
                  break;
                case ']':
                  LEXdecode(elem);
                  elem=new StringBuffer();
                  list.add(new LEX_closeSquareBracket(elem.append(data)));
                  elem=new StringBuffer();
                  break;
                case '=':
                  if (":".equals(elem.toString())) {
                    list.add(new LEX_assign(elem.append(data)));
                    elem=new StringBuffer();
                  } else if (">".equals(elem.toString())) {
                    list.add(new LEX_relation(elem.append(data),CODE_IS_GREATER_THAN_OR_EQUAL_TO));
                    elem=new StringBuffer();
                  } else if ("<".equals(elem.toString())) {
                    list.add(new LEX_relation(elem.append(data),CODE_IS_LESS_THAN_OR_EQUAL_TO));
                    elem=new StringBuffer();
                  } else{
                    LEXdecode(elem);
                    elem=new StringBuffer();
                    list.add(new LEX_relation(elem.append(data),CODE_IS_EQUAL_TO));
                    elem=new StringBuffer();
                  }
                  break;
                case '0': case '1': case '2': case '3': case '4': case'5':
                case '6': case '7': case '8': case '9':
                  if (".".equals(elem.toString())) {
                    elem.append(data);
                    codeStatus=CODE_NM_FLOAT;
                  } else {
                    LEXdecode(elem);
                    elem = new StringBuffer();
                    elem.append(data);
                    codeStatus = CODE_NM_INT_DEC;
                  }
                  break;
                case '$':
                  LEXdecode(elem);
                  elem=new StringBuffer();
                  elem.append(data);
                  codeStatus=CODE_NM_INT_HEX;
                  break;
                case '#':
                  LEXdecode(elem);
                  elem=new StringBuffer();
                  elem.append(data);
                  codeStatus=CODE_NM_CHAR;
                  break;
                case 0x0A:
                  lineCount++;
                case '\t': case 0x0D: case ' ':
                  LEXdecode(elem);
                  elem=new StringBuffer();
                  elem.append(data);
                  codeStatus=CODE_SPACE;
                  break;
                default: //pismena
                  if (((data>='a') && (data<='z')) || ((data>='A') && (data<='Z')) || (data=='_')) {
                    LEXdecode(elem);
                    elem=new StringBuffer();
                    elem.append(data);
                    codeStatus = CODE_IDENT;
                  } else {
                    if (elem.length()>0) {
                      LEXdecode(elem);
                    }
                    elem=new StringBuffer();
                    elem.append(data);
                  }
            }
            break;

          case CODE_NOTE: // ctu-li poznamku (**) {}
            switch (lastNoteSymbol) {
              case 1:
                switch (data) {
                  case ')': if ((elem.charAt(elem.length()-1)=='*') && (elem.length()>2)) {
                      elem.append(data);
                      list.add(new LEX_note(elem));
                      elem=new StringBuffer();
                      codeStatus=CODE_NORMAL;
                      break;
                    }
                  default:
                    elem.append(data);
                }
                break;
              case 2:
                switch (data) {
                  case '}':
                      elem.append(data);
                      list.add(new LEX_note(elem));
                      elem=new StringBuffer();
                      codeStatus=CODE_NORMAL;
                      break;
                  default:
                    elem.append(data);
                }
                break;
            }
            break;
        }
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
    LEXdecode(elem); //posledni hodnotu dej dekovat (mela by zbyt . nebo SPACE

    if (list.size()==0) return; // pokus nebyl soubor prazdny pokracuj

    LEX_default last=null,current=null;
    for (Iterator i=list.iterator();i.hasNext();) { // tato cast spojuje a shovava formatovani a poznamky
      current=(LEX_default) i.next();
      if (last!=null) {
        if (current.type.equals("SPACE") || current.type.equals("NOTE")) {
          last.addFollow(current);
          i.remove();
        } else last=current;
      } else last=current;
    }

    if ( // shova prvni polozku , pokud se jedna o mezery a poznamky
        (((LEX_default) list.getFirst()).type=="SPACE") ||
        (((LEX_default) list.getFirst()).type=="NOTE")
       )
   {
     ((LEX_default) list.get(1)).prev=(LEX_default) list.getFirst();
     list.remove(0);
   }

    boolean asm=false; // tato cast upravi vse co bylo nacteno mezi asm<>end
    // bude to nahreyeno LEX_asm, doposavad nespecifikovano kvuli poznamkam
    for (int i=0;i<list.size();i++) {
      LEX_default x=(LEX_default) list.get(i);
      if (asm) {
        if (x.type.equals("KEYWORD") && "end".equals(x.code.toString())) {
          asm=false;
        } else {
          list.remove(i);
          list.add(i,x.toASM());
        }
      } else if (x.type.equals("KEYWORD") && "asm".equals(x.code.toString())) asm=true;
    }

    Translator trans=new Translator(list,filename); // spusteni syntaktickeho analizatoru
    translated.add(trans);

    try { // zde se provadi vypis kodu do html
      FileWriter fw = new FileWriter(filename+".html");
      fw.write("<body bgcolor=\"Navy\">\n<center><h1><b><font color=\"white\">Obarven kd souboru <u>" + filename + "</u></font></b></h1></center>\n");
      fw.write("<h3><pre>\n");
      for (Iterator i = list.iterator(); i.hasNext(); ) {
        LEX_default lex=(LEX_default) i.next();
        //System.out.println( lex.LEXtoString());
        fw.write(lex.LEXtoHTML());
      }
      fw.write("</pre></h3>\n");
      fw.write("<p align=\"right\"><font color=\"silver\"><i>created by PaJa<i/></font></p>\n</body>\n");
      fw.close();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }



  private void LEXdecode(StringBuffer data) { // ma za ukol prelozit drobne LEXy
    if (data.length()==0) return;
    switch (data.charAt(0)) {
      case '(':
        list.add(new LEX_openBracket(data));
        break;
      case ')':
        list.add(new LEX_closeBracket(data));
        break;
      case ':':
        list.add(new LEX_colon(data));
        break;
      case ',':
        list.add(new LEX_comma(data));
        break;
      case ';':
        list.add(new LEX_semicolon(data));
        break;
      case '<':
        list.add(new LEX_relation(data,CODE_IS_LESS_THAN));
        break;
      case '>':
        list.add(new LEX_relation(data,CODE_IS_GREATER_THAN));
        break;
      case '[':
        list.add(new LEX_openSquareBracket(data));
        break;
      case ']':
        list.add(new LEX_closeSquareBracket(data));
        break;
      case '@':
        list.add(new LEX_atSign(data));
        break;
      case '.':
        list.add(new LEX_point(data));
        break;
      case '^':
        list.add(new LEX_terraceBlind(data));
        break;
      default:
        list.add(new LEX_unknown(data));
        System.out.println(data);
    }
  }

//Nasleduji jednotlive tridy repreyentujici LEX prvek. Vsechny dedi LEX_default.
//ta obsahuje vypis vlastniho kodu a vypis v html. U nekterych specifickych
//jsou tyto kody poupraveny...

  abstract class LEX_default {
    String color;
    StringBuffer code;
    LinkedList follow;
    LEX_default prev=null;
    String type;
    boolean error=false;
    int line;
    int id;

    public LEX_default() {
      follow=null;
      type="UNKNOWN";
      id=-1;
      color="Yellow";
      line=lineCount;
    }

    public void append(StringBuffer data) {
      code.append(data);
    }

    public String LEXtoString() {
      String out="<LINE " + line + " | " + ((error)?"ERROR | ":"") + type + " " + ((id>=0)?"["+id+"] ":"") + "\""+code+"\">";
      /*if (follow!=null)
        for (Iterator i=follow.iterator();i.hasNext();)
          out+=((LEX_default) i.next()).LEXtoString();*/
      return out;
    }

    public void setError() {
      error=true;
      System.out.println("Nastala chyba na dku " + line + " : " + LEXtoString());
      System.out.println("=>Ukonen smantick peklad tohoto souboru");
    }

    public String LEXtoHTMLcode() {
      if (error) {
        return "<span style=\"background-color: Red;\"><font color=\"" + color + "\">" + code + "</font></span>";
      } else return "<font color=\"" + color + "\">" + code + "</font>";
    }

    public String LEXtoHTMLfollow() {
      String out="";
      if (follow!=null)
        for (Iterator i=follow.iterator();i.hasNext();)
          out+=((LEX_default) i.next()).LEXtoHTML();
      return out;
    }

    public String LEXtoHTML() {
      return ((prev!=null)?prev.LEXtoHTML():"")+LEXtoHTMLcode()+LEXtoHTMLfollow();
    }

    public void addFollow(LEX_default data) {
      if (follow==null) follow=new LinkedList();
      follow.add(data);
    }

    public LEX_assembler toASM() {
      LEX_assembler out=new LEX_assembler();
      out.code=code;
      out.line=line;
      if (follow!=null) {
        out.follow=new LinkedList();
        for (Iterator i=follow.iterator();i.hasNext();) {
          LEX_default l=(LEX_default) i.next();
          if (l.type.equals("NOTE")) {
            out.follow.add(l);
          } else out.follow.add(l.toASM());
        }
      }
      return out;
    }
  }

  class LEX_unknown extends LEX_default {
    public LEX_unknown(StringBuffer data) {
      code=data;
    }

    public String LEXtoHTML() {
      return "<span style=\"background-color: Red;\">" + super.LEXtoHTML() + "</span>";
    }
  }

  class LEX_assembler extends LEX_default {
    public LEX_assembler(StringBuffer data) {
      type="ASSEMBLER";
      code=data;
      color="Green";
    }

    public LEX_assembler() {
      type="ASSEMBLER";
      color="Green";
    }

    public String toString() {
      return code.toString();
    }
  }

  class LEX_space extends LEX_default implements ToCPlusPlus {
    public LEX_space(StringBuffer data) {
      type="SPACE";
      code=data;
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      return code.toString();
    }
  }

  class LEX_comma extends LEX_default {
    public LEX_comma(StringBuffer data) {
      type="COMMA";
      code=data;
    }
  }

  class LEX_point extends LEX_default {
    public LEX_point(StringBuffer data) {
      type="POINT";
      code=data;
    }
  }

  class LEX_to extends LEX_default {
    public LEX_to(StringBuffer data) {
      type="TO";
      color="black";
      code=data;
    }
  }

  class LEX_atSign extends LEX_default {
    public LEX_atSign(StringBuffer data) {
      type="AT-SIGN";
      code=data;
    }
  }

  class LEX_terraceBlind extends LEX_default {
    public LEX_terraceBlind(StringBuffer data) {
      type="TERRACE_BLIND";
      code=data;
    }
  }

  class LEX_openBracket extends LEX_default {
    public LEX_openBracket(StringBuffer data) {
      type="OPEN_BRACKET";
      code=data;
    }
  }

  class LEX_closeBracket extends LEX_default {
    public LEX_closeBracket(StringBuffer data) {
      type="CLOSE_BRACKET";
      code=data;
    }
  }

  class LEX_openSquareBracket extends LEX_default {
    public LEX_openSquareBracket(StringBuffer data) {
      type="OPEN_SQUARE_BRACKET";
      code=data;
    }
  }

  class LEX_closeSquareBracket extends LEX_default {
    public LEX_closeSquareBracket(StringBuffer data) {
      type="CLOSE_SQUARE_BRACKET";
      code=data;
    }
  }

  class LEX_assign extends LEX_default {
    public LEX_assign(StringBuffer data) {
      type="ASSIGN";
      color="olive";
      code=data;
    }
  }

  class LEX_relation extends LEX_default {
    public LEX_relation(StringBuffer data,int id) {
      this.id=id;
      type="RELATION";
      color="olive";
      code=data;
    }
  }


  class LEX_colon extends LEX_default {
    public LEX_colon(StringBuffer data) {
      type = "COLON";
      code = data;
    }
  }

  class LEX_semicolon extends LEX_default {
    public LEX_semicolon(StringBuffer data) {
      type = "SEMICOLON";
      code = data;
    }
  }

  class LEX_ident extends LEX_default {
    boolean link=false;

    public LEX_ident(StringBuffer data) {
      type="IDENTIFIER";
      code=data;
    }

    public void setLink() {
      link=true;
    }

    public String LEXtoHTML() {
      return ((prev!=null)?prev.LEXtoHTML():"")+
          (link?"<a href=\"" + code + ".pas.html\">":"")+LEXtoHTMLcode()+(link?"</a>":"")+
          LEXtoHTMLfollow();
    }

    public String toString() {
      return code.toString();
    }
  }

  class LEX_label extends LEX_default {
    public LEX_label(StringBuffer data) {
      color="Maroon";
      type="LABEL";
      code=data;
    }
  }

  class LEX_string extends LEX_default implements ToCPlusPlus, GetType {
    public LEX_string(StringBuffer data) {
      type="STRING";
      color="Fuchsia";
      code=data;
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public int getType() {
      if (code.length()==3) return Translator.CHAR;
      if (code.toString().equals("''''")) return Translator.CHAR;
      return Translator.STRING;
    }

    public String toString() {
      if (getType()==Translator.CHAR)
        return "\'" + code.substring(1,code.length()-1).replaceAll("''","\\\'") + "\'";
      return "\"" + code.substring(1,code.length()-1).replaceAll("''","\\\'") + "\"";
    }
  }

  class LEX_keyword extends LEX_default {
    public LEX_keyword(StringBuffer data,int id) {
      type = "KEYWORD";
      code = data;
      color= "White";
      this.id=id;
    }

    public String LEXtoHTML() {
      String out;
      if (("begin".equals(code.toString())) || ("asm".equals(code.toString())) ||
          ("record".equals(code.toString())) || ("case".equals(code.toString())) ||
          ("object".equals(code.toString())) || ("repeat".equals(code.toString()))
          ) {
        out=super.LEXtoHTMLcode()+"<img src=\"plus.gif\" border=\"0\" alt=\"\" onclick=\"if (block"+blockCount+".style.display=='none') {block"+blockCount+".style.display='inline'; img"+blockCount+".src='minus.gif';} else {block"+blockCount+".style.display='none'; img"+blockCount+".src='plus.gif';}\" id=\"img"+blockCount+"\"><span id=\"block"+blockCount+"\" style=\"display: none;\">"+super.LEXtoHTMLfollow(); //bylo none
        blockCount++;
      } else
        if (("end".equals(code.toString())) || ("until".equals(code.toString()))){
          out = "</span>"+super.LEXtoHTML();
        } else out=super.LEXtoHTML();
      return out;
    }
  }

  class LEX_note extends LEX_default implements ToCPlusPlus {
    public LEX_note(StringBuffer data) {
      type="NOTE";
      color="silver";
      code=data;
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      if (code.charAt(0)=='{') {
        return "/*"+code.substring(1,code.length()-2)+"*/";
      } else return "/*"+code.substring(2,code.length()-3)+"*/";
    }
  }

  class LEX_operator extends LEX_default {
    public LEX_operator(StringBuffer data) {
      type="OPERATION";
      color="red";
      for (int i=0;i<OPERATORS.length;i++)
        if (OPERATORS[i].equals(data.toString())) id=i;
      code=data;
    }
  }

  class LEX_type extends LEX_default {

    public LEX_number length=null; // for String

    public LEX_type(StringBuffer data) {
      type="TYPE";
      color="aqua";
      for (int i=0;i<TYPES.length;i++)
        if (TYPES[i].equals(data.toString())) id=i;
      code=data;
    }

    public String toString() {
      for (int i=1;i<Translator.types[0].length;i++)
        if (Translator.types[0][i].equals(code.toString())) return Translator.types[1][i];
      return null;
    }
  }

  class LEX_number extends LEX_default implements ToCPlusPlus, GetType {

    public int getIntValue() {
      switch (id) {
        case CODE_NM_INT_DEC:
          return Integer.parseInt(code.toString());
        case CODE_NM_INT_HEX:
          return Integer.parseInt(code.toString().substring(1),16);
      }
      return Integer.MIN_VALUE;
    }

    public LEX_number(StringBuffer data,int typeN) {
      type = "NUMBER";
      id = typeN;
      color="lime";
      switch (typeN) {
        case CODE_NM_INT_DEC:
          type+=" [INT DEC]";
          break;
        case CODE_NM_INT_HEX:
          type+=" [INT HEX]";
          break;
        case CODE_NM_FLOAT:
          type+=" [FLOAT]";
          break;
        case CODE_NM_BOOL:
          type+=" [BOOL]";
          break;
        case CODE_NM_CHAR:
          type+=" [CHAR]";
          break;
      }
      code = data;
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public int getType() {
      switch (id) {
        case CODE_NM_CHAR:
          return Translator.CHAR;
        default:
          return Translator.INTEGER;
      }
    }

    public String toString() {
      switch (id) {
        case CODE_NM_INT_HEX:
          return "0x" + code.substring(1);
        case CODE_NM_CHAR:
          return code.substring(1);
        default:
          return code.toString();
      }
    }
  }

  /* tyto metody resi vkladani rpomennych, funckci, konstant ap. v ramci projektu
      zdroje*/

  private static void copyLinkedList(LinkedList to, LinkedList from) {
    for (Iterator i=from.iterator();i.hasNext();)
      to.add(i.next());
  }

  public static void loadHead(Translator to,String from) {
    for (Iterator i=translated.iterator();i.hasNext();) {
      Translator t=(Translator) i.next();
      if (t.name.equals(from)) {
        //copyLinkedList(to.uses.list,t.uses.list);
        copyLinkedList(to.constant.data,t.constant.data);
        copyLinkedList(to.typedef.list,t.typedef.list);
        copyLinkedList(to.subprograms,t.subprograms);
        copyLinkedList(to.subprogramsCodes,t.subprogramsCodes);
        copyLinkedList(to.var.varList,t.var.varList);
        return;
      }
    }
  }


}