package pascal2cplusplus;

import java.util.LinkedList;
import pascal2cplusplus.LexAnalyzator.LEX_default;
import java.util.Iterator;
import java.io.FileWriter;
import pascal2cplusplus.LexAnalyzator.LEX_ident;
import pascal2cplusplus.LexAnalyzator.LEX_type;
import pascal2cplusplus.LexAnalyzator.LEX_number;
import pascal2cplusplus.Translator.Type.Interval;
import pascal2cplusplus.LexAnalyzator.LEX_comma;
import pascal2cplusplus.Translator.Typedef.TypedefValue;
import pascal2cplusplus.Translator.Constant.ConstantData;
import pascal2cplusplus.LexAnalyzator.LEX_assembler;
import pascal2cplusplus.LexAnalyzator.LEX_string;
import java.io.File;
import pascal2cplusplus.LexAnalyzator.LEX_operator;

/**
 * <p>Title: Pascal2C++</p>
 * <p>Description: semestrln projekt (X36PJP+X36BPJ)</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class Translator implements Node {

  public static final String[][] types={ // definuje preklad zakladnich typu, vcetne o ktere jde
      {
          null, "byte", "shortint", "word", "integer", "longint",
          "real", "single", "double", "extended", "comp",
          "char","string",
          "boolean",
          "file","text"
      },{
          null,"char","byte","unsigned short","short","int",
          "float","double","long double","long double","long double",
          "char","char *",
          "bool",
          "fileP2CPPstruct","fileP2CPPstruct"
      }
  };

  // hodnoty repreyentujici typ, v ramci vyrazu
  public static final int ERROR = 0x00;

  public static final int BYTE = 0x11;
  public static final int SHORTINT = 0x12;
  public static final int WORD = 0x13;
  public static final int INTEGER = 0x14;
  public static final int LONGINT = 0x15;

  public static final int REAL = 0x21;
  public static final int SINGLE = 0x22;
  public static final int DOUBLE = 0x23;
  public static final int EXTENDED = 0x24;
  public static final int COMP = 0x25;

  public static final int CHAR = 0x31;
  public static final int STRING = 0x32;

  public static final int BOOLEAN = 0x41;

  public static final int FILE = 0x51;

  public static final int[] typesValue={
      ERROR,BYTE,SHORTINT,WORD,INTEGER,LONGINT,REAL,SINGLE,DOUBLE,EXTENDED,
      COMP,CHAR,STRING,BOOLEAN,FILE,FILE
  };

  // funkce pridane do p2cpp.h nebo primo prekladane
  public static final Object added[][]={
      {
       // z pohledu jazyku
          "sizeof",

        // z pohledu P2CPP.H
          "seek","read","readln",
          "write","writeln","blockread",
          "blockwrite","assign","inc",
          "dec","reset","rewrite","filesize",
          "readkey","val","str",
          "length","keypressed","new",
          "halt","ord","chr",
          "wherex","wherey","copy",
          "delay"
      },{
       // z pohledu jazyku
          new Integer(INTEGER),

        // z pohledu P2CPP.H
          new Integer(ERROR),new Integer(ERROR),new Integer(ERROR),
          new Integer(ERROR),new Integer(ERROR),new Integer(ERROR),
          new Integer(ERROR),new Integer(ERROR),new Integer(ERROR),
          new Integer(ERROR),new Integer(ERROR),new Integer(ERROR),new Integer(INTEGER),
          new Integer(CHAR),new Integer (ERROR),new Integer(ERROR),
          new Integer(INTEGER),new Integer(BOOLEAN),new Integer(ERROR),
          new Integer(ERROR),new Integer(INTEGER),new Integer(INTEGER),
          new Integer(INTEGER),new Integer(INTEGER),new Integer(STRING),
          new Integer(ERROR)
      }
  };

  Uses uses=new Uses();
  Constant constant=new Constant();
  Typedef typedef=new Typedef();
  LinkedList subprograms = new LinkedList();
  Block main=null;
  Var var=new Var();
  LinkedList subprogramsCodes = new LinkedList();

  FileWriter h = null;
  FileWriter cpp = null;

  private LinkedList data;
  private Iterator iterator;
  private int iteratorCount=-1;
  private LEX_default next;

  public String name=null;

  private Node node;

  private boolean stop=false;

  private boolean getNextWriter=true;

  private String inFunction=null;

  private LinkedList varLocal=null; // lokalni var

  private LinkedList startIndex=null;

  private Translator instantion=this;

  // nacita postupne jednotlive LEX
  private LEX_default getNext() {
    if (getNextWriter) {
      if (!iterator.hasNext()) {
        System.out.println("Predcasny konec souboru [Translator]");
        stop = true;
        return next = null;
      }
      iteratorCount++;
      return next=(LEX_default) iterator.next();
    } else {
      if (iterator.hasNext()) {
        iteratorCount++;
        return next=(LEX_default) iterator.next();
      } else return next=null;
    }
  }

  // na konec kazdeho prelozeneho souboru
  private void writeSign(FileWriter out) throws Exception {
    out.write("\n\n\n");
    out.write("/**[verze 1.0.000]*****************************************/\n");
    out.write("/* Tento soubor byl vytvoren pomoci prekladace Pascal2C++ */\n");
    out.write("/* vytvoreny Pavlem Jaresem jako                          */\n");
    out.write("/*                                                        */\n");
    out.write("/*  semestralni prace z predmetu                          */\n");
    out.write("/*   Programovaci jazyky a preklace                       */\n");
    out.write("/*                                                        */\n");
    out.write("/*  a jako Semestralni projekt v bakalarske etape FEL VT  */\n");
    out.write("/*                                                        */\n");
    out.write("/*  created by PaJa                                       */\n");
    out.write("/*             Pavel.Jares@seznam.cz                      */\n");
    out.write("/********************************************[leden 2oo6]**/\n");
  }

  //je LEX cislo? jakekoliv?
  public boolean isNumber() {
    if (next.type.indexOf("NUMBER")>=0) return true;
    if (!next.type.equals("IDENTIFIER")) return false;
    for (Iterator i=constant.data.iterator();i.hasNext();) {
      ConstantData cd=(ConstantData) i.next();
      if (next.code.toString().equals(cd.name.code.toString())) {
        next=cd.value.lex;
        return true;
      }
    }
    return false;
  }

  //je identifikator nazev procedury nebo fce?
  private boolean isSubprogram(Identifier ident) {
    String name=ident.toString();
    for (Iterator i=subprograms.iterator();i.hasNext();)
      if (((ProcedureDefinition) i.next()).name.code.toString().equals(name))
        return true;
    for (int i=0;i<added[0].length;i++)
      if (added[0][i].equals(name))
        return true;
    return false;
  }

  /**
   * Nasledujici funkce urci pri zadani identifikatoru, jaky ma typ.
   * Tyto metody prochazeni jak vlsatni globalni, lokalni ale i vlozene z
   * knihoven. Hleda mezi var, funkcemi a procedury.
   * Dokaze zjistit i typ recordu, nebo indexu pole ci stringu (char)
   */

  private int getTypeTypeVar(Type typeIn,Identifier ident) {
    Type type=typeIn;
    while (type.typedefValue!=null)
      type=type.typedefValue.type;
    if (ident==null) {
      int out = type.getType();
      if (out==STRING) startIndex.add("1");
      return out;
    }

    if ((ident.nextIdentifier==null) && (ident.indexsOfArray==null)&& (type.var==null)) {
      int out=type.getType();
      if (out==STRING) startIndex.add("1");
      return out;
    }
    if (ident.indexsOfArray!=null) {
      if (ident.indexsOfArray.size()==type.dimDefinited.size()) {
        for (Iterator i=type.dimDefinited.iterator();i.hasNext();)
          startIndex.add(((Interval) i.next()).from);
        return getTypeTypeVar(type.ofType,ident.nextIdentifier);
      } else {
        if ((ident.indexsOfArray.size()==1) && (ident.nextIdentifier==null)) {
          startIndex.add("1");
          return CHAR;
        } else return ERROR;
      }
    }
    if (type.typedefValue!=null) type=type.typedefValue.type;
    if (ident.nextIdentifier!=null) {
      if (type.var!=null) {
        return getTypeVar(ident.nextIdentifier,type.var.varList);
      } else return getTypeTypeVar(type,ident.nextIdentifier);
    } else {if (type.var!=null) {
        return getTypeVar(ident,type.var.varList);
      } else return getTypeTypeVar(type,ident);
    }
    //return ERROR;
  }

  private int getTypeVar(Identifier ident,LinkedList var) {
    for (Iterator i=var.iterator();i.hasNext();) {
      VarValue v=(VarValue) i.next();
      for (Iterator j=v.names.iterator();j.hasNext();)
        if (j.next().toString().equals(ident.identifier.toString())) {
          return getTypeTypeVar(v.type,ident);
        }
    }
    return -1;
  }

  private VarValue getVarValue(Identifier ident,LinkedList var) {
    for (Iterator i=var.iterator();i.hasNext();) {
      VarValue v=(VarValue) i.next();
      for (Iterator j=v.names.iterator();j.hasNext();)
        if (j.next().toString().equals(ident.identifier.toString())) {
          return v;
        }
    }
    return null;
  }

  private VarValue getVarValue(Identifier ident) {
    VarValue vv=getVarValue(ident,varLocal);
    if (vv==null) return getVarValue(ident,var.varList);
    return vv;
  }

  private int getIdentifierType(Identifier ident) {
    startIndex=new LinkedList();
    String name=ident.identifier.code.toString();
    for (Iterator i=subprograms.iterator();i.hasNext();) {
      ProcedureDefinition pd=(ProcedureDefinition) i.next();
      if (pd.name.code.toString().equals(name))
        if (pd.type.equals("procedure")) {
          return ERROR;
        } else return ((FunctionDefinition) pd).returnType.getType();
    }
    for (int i=0;i<added[0].length;i++)
      if (added[0][i].equals(name))
        return ((Integer) added[1][i]).intValue();


    int i;
    if (varLocal!=null) {
      i = getTypeVar(ident, varLocal);
      if (i != -1) return i;
    }
    i=getTypeVar(ident,var.varList);
    if (i!=-1) return i;

    for (Iterator it=constant.data.iterator();it.hasNext();) {
      ConstantData cd = (ConstantData) it.next();
      if (ident.identifier.toString().equals(cd.name.toString())) {
        if (cd.typ == null) {
          return cd.value.getType();
        }
        {}
        if (cd.typ.var != null) return getTypeVar(ident.nextIdentifier, cd.typ.var.varList);//return cd.typ.getType();
        if ((ident.indexsOfArray!=null) && (cd.typ.dimDefinited!=null)) {
          if (ident.indexsOfArray.size()==cd.typ.dimDefinited.size()) {
            for (Iterator j=cd.typ.dim.iterator();j.hasNext();)
              startIndex.add(((Interval) j.next()).from);
            return cd.typ.ofType.getType();
          } else return ERROR;
        }
        if ((ident.indexsOfArray!=null) || (cd.typ.dimDefinited!=null)) return ERROR;
        return getTypeVar(ident.nextIdentifier, cd.typ.var.varList);
      }
    }

    return ERROR;
  }

  /**
   * Konstruktor tridy Translator
   * rozhodne jdeli o knihovnu ci nikoliv, zapamatuje si nazev souboru a da
   * prekladat.
   */
  public Translator(LinkedList data,String filename) {
    name=filename.split(".pas")[0];
    this.data=data;
    this.iterator=data.iterator();
    if (getNext().code.toString().equals("unit")) {
      node=new Unit();
    } else node=new Program();
    node.decode();
  }

  public void writeHTML(FileWriter out) {
  }

  public void writeCode(FileWriter out) {
  }

  public void decode() {
  }

  /** Tato trida repreyentuje celou knihovnu. Od tridy Program se lisi pouze
   * v jinem poradi dekodovani, resp. v ruznem poradi a obsahu kodu...
   */


  class Unit implements Node {

    SpacesManager spaces=new SpacesManager();

    public Unit() {}

    public void decode() {
      if (!getNext().type.equals("IDENTIFIER")) {
        next.setError();
        return;
      } else {
        name=next.code.toString();
      }
      if (!getNext().type.equals("SEMICOLON")) {
       next.setError();
       return;
      }
      if (!getNext().code.toString().equals("interface")) {
       next.setError();
       return;
      }

      /*if (!stop)*/ decodeHead();

      writeHead();

      if (!stop) {
        for (Iterator i=uses.list.iterator();i.hasNext();) {
          String n=((LEX_default) i.next()).code.toString()+".pas";
          new LexAnalyzator(n);
          LexAnalyzator.loadHead(instantion,n);
        }
      }

      if (!stop) decodeBody();
      //System.out.println(this.subprogramsCodes.size());
      if (!stop) decodeMain();



      if (stop) System.out.println("Error(s) detected");
      writeMain();
     /* for (Iterator i=uses.list.iterator();i.hasNext();) {
          new LexAnalyzator(((LEX_default) i.next()).code.toString()+".pas");
      }*/
    }

    private void writeHead() {
      try {
        h = new FileWriter(name + ".h");
        cpp = new FileWriter(name + ".cpp");

        h.write("#include \"p2cpp.h\"\n");

        cpp.write("#include \"stdafx.h\"\n");
        cpp.write("#include <stdlib.h>\n");
        cpp.write("#include \"math.h\"\n");
        cpp.write("#include \"p2cpp.h\"\n");


        cpp.write("#include \"" + name + ".h\"\n\n");
        uses.write(h);

        constant.write(h);
        typedef.write(h);
        var.write(h);


        for (Iterator i=subprograms.iterator();i.hasNext();) {
          ((ToCPlusPlus) i.next()).write(h);
          h.write(";\n");
        }

      } catch (Exception e) {
        e.printStackTrace();
      }
    }

    private void writeMain() {
      try {
        for (Iterator i=subprogramsCodes.iterator();i.hasNext();) {
          ((ToCPlusPlus) i.next()).write(cpp);
        }

        if (main!=null) {
          h.write("void " + name + "main();");
          cpp.write("void " + name + "main()");
          main.write(cpp);
        }
        writeSign(h);
        writeSign(cpp);

        h.close();
        cpp.close();
      } catch (Exception e) {
        e.printStackTrace();
      }
    }

    private void decodeHead() {
      getNext();
      while (true) {
        boolean status=false,readNext=true;
        String first=next.code.toString();
        if (first.equals("uses")) {
          uses.decode();
          readNext=true;
          status=true;
          if (stop) return;
        }
        if (first.equals("const")) {
          constant.decode();
          readNext=false;
          status=true;
          if (stop) return;
        }
        if (first.equals("type")) {
          typedef.decode();
          status=true;
          readNext=false;
          if (stop) return;
        }
        if (first.equals("var")) {
          var.decode();
          readNext=false;
          status=true;
          if (stop) return;
        }
        if (first.equals("procedure")) {
          ProcedureDefinition p=new ProcedureDefinition();
          p.decode();
          subprograms.add(p);
          status=true;
        }
        if (first.equals("function")) {
          FunctionDefinition f=new FunctionDefinition();
          f.decode();
          subprograms.add(f);
          status=true;
        }
        if (!status) {
          next.setError();
          stop=true;
          break;
        }
        if (readNext) getNext();
        if (next.code.toString().equals("implementation")) {
          return;
        }
        if (next==null) {
          System.out.println("Neukonen soubor...");
          System.exit(0);
        }
      }
    }

    private void decodeBody() {
      while (true) {
        if (stop) return;
        String first=getNext().code.toString();
        if (first.equals("begin")) return;
        if (first.equals("end")) return;
        if (first.equals("procedure")) {
          Procedure p=new Procedure();
          p.decode();
          subprogramsCodes.add(p);
          continue;
        }
        if (first.equals("function")) {
          Function f=new Function();
          f.decode();
          subprogramsCodes.add(f);
          continue;
        }
      }
    }

    private void decodeMain() {
      if (next.code.toString().equals("begin")) {
        main = new Block();
        main.decode();
      } else {
        if (!next.code.toString().equals("end")) {
          next.setError();
          stop = true;
          return;
        }
        getNext();
      }
      if (!next.type.equals("POINT")) {
        next.setError();
        stop=true;
        return;
      }
    }

    public void writeHTML(FileWriter out) {
    }

    public void writeCode(FileWriter out) {
    }
  }

  class Program implements Node {

    LEX_default first=null;
    Node follow=null;
    Block main=null;

    SpacesManager spaces=new SpacesManager();

    public void writeHTML(FileWriter out) {
    }

    public void writeCode(FileWriter out) {
    }

    public void decode() {
      decodeBody();

      writeHead();
      if (!stop) {
        for (Iterator i=uses.list.iterator();i.hasNext();) {
          String n=((LEX_default) i.next()).code.toString()+".pas";
          new LexAnalyzator(n);
          LexAnalyzator.loadHead(instantion,n);
        }
      }

      if (stop) return;
      if (!next.code.toString().equals("begin")) {
        next.setError();
        stop=true;
        return;
      }
      main=new Block();
      main.decode();
      if (!next.type.equals("POINT")) {
       next.setError();
       stop=true;
       return;
     }
     writeMain();
    }

    private void decodeBody() {
      while (true) {
        boolean status = false, readNext = true;
        String first = next.code.toString();
        //System.out.println(first);
        if (first.equals("uses")) {
          uses.decode();
          readNext = true;
          status = true;
          if (stop)
            return;
        }
        if (first.equals("program")) {
          if (!getNext().type.equals("IDENTIFIER")) {
            next.setError();
            stop=true;
            return;
          }
          name=next.code.toString();
          readNext = true;
          status = true;
          if (!getNext().type.equals("SEMICOLON")) {
            next.setError();
            stop=true;
            return;
          }
          if (stop) return;
        }

        if (first.equals("const")) {
          constant.decode();
          readNext = false;
          status = true;
          if (stop)
            return;
        }
        if (first.equals("type")) {
          typedef.decode();
          status = true;
          readNext = false;
          if (stop)
            return;
        }
        if (first.equals("var")) {
          var.decode();
          readNext = false;
          status = true;
          if (stop)
            return;
        }
        if (first.equals("procedure")) {
          Procedure p = new Procedure();
          p.decode();
          subprogramsCodes.add(p);
          subprograms.add(p.definition);
          status = true;
        }
        if (first.equals("function")) {
          Function f = new Function();
          f.decode();
          subprogramsCodes.add(f);
          subprograms.add(f.definition);
          status = true;
        }
        if (!status) {
          next.setError();
          stop = true;
          break;
        }
        if (readNext) getNext();
        if (next.code.toString().equals("begin")) {
          return;
        }
        if (next == null) {
          System.out.println("Neukonen soubor...");
          System.exit(0);
        }
      }
    }

    private void writeHead() {
      try {
        cpp = new FileWriter(name + ".cpp");

        cpp.write("#include \"stdafx.h\"\n");
        cpp.write("#include <stdlib.h>\n");
        cpp.write("#include \"math.h\"\n");
        cpp.write("#include \"p2cpp.h\"\n");
        uses.write(cpp);

        constant.write(cpp);
        typedef.write(cpp);
        var.write(cpp);


        for (Iterator i=subprogramsCodes.iterator();i.hasNext();) {
          ((ToCPlusPlus) i.next()).write(cpp);
        }
      } catch (Exception e) {
        e.printStackTrace();
      }
    }

    private void writeMain() {
      try {
        cpp.write("void main()");
        //for (Iterator i=uses.list.iterator();i.hasNext();) {
        //  new LexAnalyzator(((LEX_ident) i.next()).code.toString()+".pas");
        //}

        /*cpp.write("{\n");
        for (Iterator i=LexAnalyzator.done.iterator();i.hasNext();) {
          cpp.write(((LEX_default) i.next()).code.toString() + "main();\n");
        }

        for (Iterator i=main.list.iterator();i.hasNext();) {
          ((ToCPlusPlus) i.next()).write(cpp);
        }
        cpp.write("{\n");*/

        main.write(cpp);

        writeSign(cpp);
        cpp.close();
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
  }

  class Uses implements ToCPlusPlus {
    LinkedList list=new LinkedList();
    SpacesManager spaces=new SpacesManager();
    public Uses() {}
    public void decode() {
      while (getNext().type.equals("IDENTIFIER")) {
        spaces.add(next);
        list.add(next);
        ((LEX_ident) next).setLink();
        if (getNext().type.equals("SEMICOLON")) return;
        if (!next.type.equals("COMMA")) {
            next.setError();
            stop=true;
            return;
        }
      }
      spaces.add(next);
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      spaces.start();
      String out="";
      if (list.size()==0) return out;
      if (((LEX_default) list.get(0)).prev!=null)
        out+=(ToCPlusPlus) ((LEX_default) list.get(0)).prev;
      out+=spaces.get();
      for (Iterator i=list.iterator();i.hasNext();) {
        LEX_ident unit=(LEX_ident) i.next();
        File file=new File(unit.code.toString()+".pas");
        if (file.exists()) {
          out+="#include \"" + unit.code.toString() + ".h\"\n";
        } else out+="//#include \"" + unit.code.toString() + ".h\" /* Soubor nebyl nalezen, protoze je mozne, ze se jedna od nejakou knihovnu TP nahrazenou knihovnou P2CPP.H, byla ignorovana a preklad pokracoval bez ni...*/\n";
        if (unit.follow!=null)
          for (Iterator j=unit.follow.iterator();j.hasNext();)
            out+=j.next();
      }
      return out+spaces.get();
    }
  }

  class Constant implements ToCPlusPlus {

    LinkedList data=new LinkedList();
    SpacesManager spaces=new SpacesManager();

    public Constant() {}
    public void decode() {
      while (true) {
        ConstantData cd=new ConstantData();
        if (getNext().type.equals("IDENTIFIER")) {
          cd.name=(LEX_ident) next;
          getNext();
          if (next.type.equals("COLON")) {
            cd.typ=new Type();
            cd.typ.decode();
            if (getNext().code.toString().equals("=")) {
              cd.value=new Value(cd.typ);
            }
          } else if (next.code.toString().equals("=")) {
            cd.value=new Value();
          } else {
            next.setError();
            stop=true;
            return;
          }
          if (!getNext().type.equals("SEMICOLON")) {
            next.setError();
            stop=true;
            return;
          }
        } else return;
        data.add(cd);
        spaces.add(next);
      }
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      spaces.start();
      String out="";
      for (Iterator i=data.iterator();i.hasNext();)
        out+=i.next()+spaces.get();
      return out;
    }

    class ConstantData implements ToCPlusPlus {
      LEX_ident name=null;
      Type typ=null;
      Value value=null;
      public void write(FileWriter out) throws Exception {
        out.write(toString());
      }

      public String toString() {
        String out="";
        if (typ==null) {
          out+="#define " + name.code.toString() + " ";
          out+=value.toString();
        } else {
          out+="const ";
          out+=typ.beforeToString();
          out+=" " + name.code.toString() + typ.afterToString() + "=";
          out+=value;
          out+=";";
        }
        return out;
      }
    }
  }

  class Type implements ToCPlusPlus {

    boolean array=false;
    boolean dynamic=false;
    boolean procedure=false;
    LEX_type lex=null;
    Type ofType=null;
    TypedefValue typedefValue=null;
    LinkedList dim=new LinkedList(),dimDefinited=new LinkedList();
    Var var=null;

    public int getType() {
      if (array) return ERROR;
      if (lex!=null) {
        String name=lex.code.toString();
        for (int i=1;i<types[0].length;i++)
          if (name.equals(types[0][i]))
            return typesValue[i];
      }
      return ERROR;
    }

    public Type() {}

    public void decode() {
      decode(false);
    }

    public void decode(boolean definition) {

      getNext();

      if (next.type.equals("TERRACE_BLIND")) {
        dynamic=true;
        getNext();
      }


      if (next.code.toString().equals("procedure")) {
        procedure=true;
        return;
      }

      if (next.code.toString().equals("record")) {
          var=new Var();
          var.decode();
          if (!next.code.toString().equals("end")) {
            next.setError();
            stop=true;
            return;
          }
          return;
      }

      if (next.type.equals("IDENTIFIER")) {
        for (Iterator i = typedef.list.iterator(); i.hasNext(); ) {
          TypedefValue tdv = (TypedefValue) i.next();
          if (tdv.name.code.toString().equals(next.code.toString())) {
            typedefValue = tdv;
            return;
          }
        }
      }

      if (!next.type.equals("TYPE")) {
        next.setError();
        stop=true;
        return;
      }
      lex=(LEX_type) next;
      if (lex.code.toString().equals("string")) {
        if (!definition) {
          if ( ( (LEX_default) data.get(iteratorCount + 1)).type.equals(
              "OPEN_SQUARE_BRACKET")) {
            getNext();
            getNext();
            if (isNumber()) {
              lex.length = (LEX_number) next;
            }
            else {
              next.setError();
              stop = true;
              return;
            }
            if (!getNext().type.equals("CLOSE_SQUARE_BRACKET")) {
              next.setError();
              stop = true;
              return;
            }
          }
        }
      }
      array=(lex.code.toString().equals("array"));
      if (array) {
        if (!definition) {
          if (!getNext().type.equals("OPEN_SQUARE_BRACKET")) {
            next.setError();
            stop = true;
            return;
          }
          while (true) {
            Interval i = new Interval();
            LinkedList l=new LinkedList();
            while (!getNext().type.equals("TO"))
              l.add(next);
            i.from=new Term(l);
            if (!next.type.equals("TO")) {
              next.setError();
              stop = true;
              return;
            }
            l=new LinkedList();
            while (!((getNext().type.equals("CLOSE_SQUARE_BRACKET")) || (next.type.equals("COMMA"))))
              l.add(next);
            i.to=new Term(l);
            dim.add(i);
            dimDefinited.add(i);
            if (!next.type.equals("COMMA"))
              break;
          }
          if (!next.type.equals("CLOSE_SQUARE_BRACKET")) {
            next.setError();
            stop = true;
            return;
          }
          if ( (dim.size() == 0) || (!getNext().code.toString().equals("of"))) {
            next.setError();
            stop = true;
            return;
          }
        } else {
          if (!getNext().code.toString().equals("of")) {
            next.setError();
            stop = true;
            return;
          }
        }
        ofType=new Type();
        ofType.decode();
        if (ofType.typedefValue!=null)

        if (ofType.typedefValue.type.array) {
          for (Iterator i=ofType.typedefValue.type.dim.iterator();i.hasNext();) {
            dim.add(i.next());
          }
          ofType=ofType.typedefValue.type.ofType;
        }
        return;
      }
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String afterToString() {
      String out="";
      if ((lex!=null) && (lex.code.toString().equals("string")))
        return "[" + ((lex.length==null)?"256":""+(lex.length.getIntValue()+1))+"]";
      if (array) {
        for (Iterator i=dimDefinited.iterator();i.hasNext();) {
          out+="[";
          Interval interval=(Interval) i.next();
          out+=""+(interval.to.getIntValue()-interval.from.getIntValue()+1);
          out+="]";
        }
      }
      return out + ((array)?ofType.afterToString():"");
    }

    public String beforeToString() {
      String out="";
      if (array) out+=ofType.beforeToString();
      if (var!=null) {
        out+="struct {"+var.toString()+"}";
      }
      if (procedure) out+="void";
      if (array) return out;
      if (lex!=null) {
        if (lex.code.toString().equals("string")) {
          out+="char";
        } else  out += lex.toString();
      }
      if (typedefValue!=null) out+=typedefValue.name.code.toString();
      if (dynamic) out+="*";
      return out;
    }

    public String toString() {
      return beforeToString() + afterToString();
    }

    class Interval {
      public Term from,to;
    }
  }

  class Value implements ToCPlusPlus {

    LEX_default lex=null;
    Type typ=null;
    boolean array;
    LinkedList arrayData=null;

    private void getOrder(LinkedList intervals,int level,LinkedList out) {
      int size=((Term) ((Interval) intervals.get(level)).to).getIntValue()-
          ((Term) ((Interval) intervals.get(level)).from).getIntValue()+1;
      out.add("OPEN_BRACKET");
      for (int i=0;i<size;i++) {
        if (i>0) out.add("COMMA");
        if (level+1<intervals.size()) {
          getOrder(intervals,level+1,out);
        } else {
          out.add("NUMBER");
        }
      }
      out.add("CLOSE_BRACKET");
    }

    public Value(Type typ) { //array or no?
      arrayData=new LinkedList();
      array=typ.array;
      if (!array) {
        getNext();
        if ((isNumber()) || (next.type.equals("STRING"))) {
          lex=next;
        } else {
          next.setError();
          stop=true;
          return;
        }
        return;
      }
      this.typ=typ;
      LinkedList order=new LinkedList();
      getOrder(typ.dim,0,order);
      for (Iterator i=order.iterator();i.hasNext();) {
        getNext();
        String n=(String) i.next();
        if (n.equals("NUMBER")) {
          LinkedList p=new LinkedList();
          p.add(next);
          while (true) {
            getNext();
            if (next.type.equals("COMMA") || next.type.equals("CLOSE_BRACKET")) {
              arrayData.add(new Term(p));
              break;
            } else p.add(next);
          }
          if (!next.type.equals(i.next().toString())) {
            next.setError();
            stop=true;
            return;
          }
          continue;
        }
        if (!next.type.equals(n.toString())) {
          next.setError();
          stop=true;
          return;
        }

      }
    }

    public Value() { // no array
      array=false;
      getNext();
      if (isNumber() || (next.type.equals("STRING"))) {
        lex=next;
      } else {
        next.setError();
        stop=true;
        return;
      }
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      String out="";
      if (array) {
        LinkedList order=new LinkedList();
        getOrder(typ.dim,0,order);
        Iterator i=arrayData.iterator();
        for (Iterator j=order.iterator();j.hasNext();) {
          String name=(String) j.next();
          if (name.equals("COMMA")) out+=",";
          if (name.equals("OPEN_BRACKET")) out+="{";
          if (name.equals("CLOSE_BRACKET")) out+="}";
          if (name.equals("NUMBER")) out+=((ToCPlusPlus) i.next()).toString();
        }
      } else {
        out+=((ToCPlusPlus) lex).toString();
      }
      return out;
    }

    private int getType() {
      if (typ!=null) return typ.getType();
      if (arrayData!=null)
        if (arrayData.size()>0)
          return ((GetType) arrayData.getLast()).getType();
      return ERROR;
    }
  }

  class Typedef implements ToCPlusPlus {

    LinkedList list=new LinkedList();
    SpacesManager spaces=new SpacesManager();

    public Typedef() {
    }

    public void decode() {
      TypedefValue tdv=new TypedefValue();
      if (!getNext().type.equals("IDENTIFIER")) {
        return;
      }
      tdv.name=(LEX_ident) next;
      if (!getNext().code.toString().equals("=")) {
        next.setError();
        stop=true;
        return;
      }
      tdv.type=new Type();
      tdv.type.decode();
      list.add(tdv);
      if (stop) return;
      if (!getNext().type.equals("SEMICOLON")) {
        next.setError();
        stop=true;
        return;
      }
      spaces.add(next);
      if (!stop) decode();
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      spaces.start();
      String out="";
      for (Iterator i=list.iterator();i.hasNext();)
        out+=i.next().toString()+spaces.get();
      return out;
    }

    class TypedefValue implements ToCPlusPlus {
      LEX_ident name=null;
      Type type=null;
      public void write(FileWriter out) throws Exception {
        out.write(toString());
      }

      public String toString() {
        return "typedef " + type.beforeToString() + " " + name.code.toString() + type.afterToString() + ";";
      }
    }
  }

  class VarValue implements ToCPlusPlus {
    LinkedList names=new LinkedList();
    Type type=null;
    boolean definition=false;
    boolean reference=false;

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      String out="",before,after;
      before=type.beforeToString();
      after=type.afterToString();

      boolean string=false;
      if (type.lex!=null) string=type.lex.code.toString().equals("string");
      Type t=type;
      while (t.ofType!=null)
        t=t.ofType;
      if (type.lex!=null) string=type.lex.code.toString().equals("string");

      if (string && definition) {
        int indexs=(type.dimDefinited==null)?0:type.dimDefinited.size();
        for (Iterator i = names.iterator(); i.hasNext(); ) {
          out += "char ";
          for (int j=0;j<indexs+1;j++)
            out+="*";
          out += i.next().toString();
          if (i.hasNext()) out+=",";
        }
        return out;
      }

      if (!definition) out+=before+(reference ? " &" : " ");
      for (Iterator i = names.iterator(); i.hasNext(); ) {
        if (definition) out+=before+(reference ? " &" : " ");
        out+=( (LEX_default) i.next()).code.toString()+after;
        if (i.hasNext()) {
          out+=",";
        } else if (!definition) out+=";\n";
      }

      return out;
    }
  }

  class Var implements ToCPlusPlus {

    SpacesManager spaces=new SpacesManager();
    LinkedList varList=new LinkedList();
    boolean definition=false;

    public void decode() {
      decode(false);
    }

    public void decode(boolean definition) {
      this.definition=definition;
      VarValue vv=null;
      while (true) {
        boolean stop=true;
        vv=new VarValue();
        while ((getNext().type.equals("IDENTIFIER")) || (definition && (next.code.toString().equals("var")))) {
          boolean refer=false;
          if (definition && (next.code.toString().equals("var"))) {
            refer=true;
            if (!getNext().type.equals("IDENTIFIER")) {
              next.setError();
              stop=true;
              return;
            }
          }
          stop=false;
          vv.definition=definition;
          vv.names.add(next);
          vv.reference=refer;
          if (getNext().type.equals("COLON")) break;
          if (!next.type.equals("COMMA")) {
            next.setError();
            stop = true;
            return;
          }
        }
        if (stop) return;
        vv.type = new Type();
        vv.type.decode(definition);
        varList.add(vv);
        if (!definition) {
          if (!getNext().type.equals("SEMICOLON")) {
            next.setError();
            stop = true;
            return;
          }
        } else {
          if (!getNext().type.equals("SEMICOLON")) return;
        }
        spaces.add(next);
      }
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      spaces.start();
      String out="";
      for (Iterator i=varList.iterator();i.hasNext();) {
        out+=i.next().toString();
        if (definition && i.hasNext()) out+=",";
      }
      return out+spaces.get();
    }
  }

  class ProcedureDefinition implements ToCPlusPlus {
    String type="procedure";
    class Parameters implements ToCPlusPlus {
      Var var=new Var();
      public void decode() {
        if (getNext().type.equals("SEMICOLON")) return;
        if (next.type.equals("COLON")) return;
        if (next.type.equals("OPEN_BRACKET")) {
          var.decode(true);
        } else {
          next.setError();
          stop=true;
          return;
        }
        if (!next.type.equals("CLOSE_BRACKET")) {
          next.setError();
          stop=true;
          return;
        }
        getNext();
      }

      public void write(FileWriter out) throws Exception {
        out.write(toString());
      }

      public String toString() {
        return "(" + var.toString() + ")";
      }
    }

    LEX_ident name=null;
    Parameters parameters=new Parameters();

    public void decode() {
      if (getNext().type.equals("IDENTIFIER")) {
        name=(LEX_ident) next;
      } else {
        next.setError();
        stop=true;
        return;
      }
      parameters.decode();
      if (!next.type.equals("SEMICOLON")) {
        next.setError();
        stop = true;
        return;
      }
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      return "void " + name.code.toString()+((ToCPlusPlus) parameters).toString();
    }
  }

  class FunctionDefinition extends ProcedureDefinition implements ToCPlusPlus {

    Type returnType=new Type();

    public FunctionDefinition() {
      type="function";
    }

    public void decode() {
      if (getNext().type.equals("IDENTIFIER")) {
        name=(LEX_ident) next;
      } else {
        next.setError();
        stop=true;
        return;
      }
      parameters.decode();
      if (!next.type.equals("COLON")) {
        next.setError();
        stop = true;
        return;
      }
      returnType.decode();
      if (!getNext().type.equals("SEMICOLON")) {
        next.setError();
        stop = true;
        return;
      }
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      if (returnType.getType()==STRING)
        return "char* " + name.code.toString()+((ToCPlusPlus) parameters).toString();
      return returnType.toString() + " " + name.code.toString()+((ToCPlusPlus) parameters).toString();
    }

  }

  class Procedure implements ToCPlusPlus {

    SpacesManager spaces=new SpacesManager();

    ProcedureDefinition definition=new ProcedureDefinition();
    Block block=null;
    Var var=null;
    Asm asm=null;

    private void loadLocalVar() {
      varLocal=new LinkedList();
      if (var!=null)
        for (Iterator i=var.varList.iterator();i.hasNext();)
          varLocal.add(i.next());
      if (definition.parameters.var!=null)
        for (Iterator i=definition.parameters.var.varList.iterator();i.hasNext();)
          varLocal.add(i.next());
    }

    public void decode() {
      definition.decode();
      spaces.add(next);

      if (getNext().code.toString().equals("assembler")) {
        if (!getNext().type.equals("SEMICOLON")) {
          next.setError();
          stop=true;
          return;
        }
        if (getNext().code.toString().equals("var")) {
          var=new Var();
          var.decode(false);
        }
        loadLocalVar();
        if (!next.code.toString().equals("asm")) {
          next.setError();
          stop = true;
          return;
        }
        asm=new Asm();
        asm.decode();
        return;
      }

      block=new Block();
      var=new Var();


      if (next.code.toString().equals("var")) {
        var.decode(false);
      }
      loadLocalVar();
      block.decode();
      if (stop) return;
      if (!next.type.equals("SEMICOLON")) {
        next.setError();
        stop=true;
        return;
      }
      spaces.add(next);
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      loadLocalVar();
      spaces.start();
      String out=definition.toString() + "{" + spaces.get();
      if (var!=null) out+=var.toString();
      if (block!=null)
        if (block.list!=null) {
          block.spaces.start();
          for (Iterator i = block.list.iterator(); i.hasNext(); ) {
            out += i.next().toString() + ";" + block.spaces.get();
          }
        }
      if (asm!=null) out+=asm.toString();
      varLocal.clear();
      return out+"}" + ((block==null)?"":block.spaces.get());
    }
  }

  class Function implements ToCPlusPlus {

    SpacesManager spaces=new SpacesManager();

    FunctionDefinition definition = new FunctionDefinition();
    Block block=null;
    Var var = null;
    Asm asm = null;

    private void loadLocalVar() {
      varLocal=new LinkedList();
      if (var!=null)
        for (Iterator i=var.varList.iterator();i.hasNext();)
          varLocal.add(i.next());
      if (definition.parameters.var!=null)
        for (Iterator i=definition.parameters.var.varList.iterator();i.hasNext();)
          varLocal.add(i.next());
    }

    public void decode() {
      definition.decode();
      spaces.add(next);
      String bakInFunction=inFunction;
      inFunction=definition.name.code.toString();

      if (getNext().code.toString().equals("assembler")) {
        if (!getNext().type.equals("SEMICOLON")) {
          next.setError();
          stop = true;
          return;
        }
        if (getNext().code.toString().equals("var")) {
          var=new Var();
          var.decode(false);
        }
        loadLocalVar();
        if (!next.code.toString().equals("asm")) {
          next.setError();
          stop = true;
          return;
        }
        asm = new Asm();
        asm.decode();
        return;
      }

      block = new Block();
      var = new Var();
      loadLocalVar();
      if (next.code.toString().equals("var")) {
        var.decode(false);
      }
      block.decode();

      inFunction=bakInFunction;

      if (!next.type.equals("SEMICOLON")) {
        next.setError();
        stop = true;
        return;
      }
      spaces.add(next);
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      loadLocalVar();
      spaces.start();
      if (block!=null) block.spaces.start();
      String out=definition.toString() + spaces.get() + "{" + ((block==null)?"\n":block.spaces.get());
      if (var!=null) out+=var.toString();
      if (block!=null)
        if (block.list!=null)
          for (Iterator i=block.list.iterator();i.hasNext();) {
            out+=i.next().toString()+";\n"+block.spaces.get();
          }
      if (asm!=null) {
        String typ;
        out+=(typ=definition.returnType.toString())+" result;\n";
        if (asm.data!=null) {
          out+="asm {";
          boolean result=false;
          for (Iterator i=asm.data.iterator();i.hasNext();) {
            LEX_assembler lex=(LEX_assembler) i.next();
            if (lex.code.toString().equals("@result")) {
              out+="result";
              result=true;
            } else out+=lex.code.toString();
            if (lex.follow!=null)
              for (Iterator j=lex.follow.iterator();j.hasNext();)
                out+=j.next().toString();
          }
          if (!result) {
            out+="mov result,a";
            if (typ.equals("byte") || typ.equals("char") || typ.equals("bool")) {
              out+="l\n";
            } else out+="x\n";
          }
          out+="};\n";
        }
        out+="return result;\n";
      }
      varLocal.clear();
      return out+"}\n";
    }

  }

  abstract class Command implements ToCPlusPlus {
    String type=null;

    SpacesManager spaces=new SpacesManager();

    public abstract void setError();

    public Command read() { // dekodovani jednoho elementu bez ; (dalsi LEX nacten)
      Command out=null;

      if (next.type.equals("IDENTIFIER") || next.type.equals("AT-SIGN")) {
        Identifier name = new Identifier();
        name.decode();
        if (next.type.equals("SEMICOLON") || next.type.equals("KEYWORD")) {
          return new Calling(name);
        }
        if (next.type.equals("OPEN_BRACKET")) {
          int count=0;
          LinkedList param = new LinkedList();
          LinkedList p=new LinkedList();
          while (!stop) {
            if (getNext().type.equals("CLOSE_BRACKET") || next.type.equals("CLOSE_SQUARE_BRACKET")) {
              if (count==0) {
                param.add(new Term(p));
                break;
              } else {
                count--;
                p.add(next);
                continue;
              }
            }
            if (next.type.equals("OPEN_BRACKET") || next.type.equals("OPEN_SQUARE_BRACKET")) {
              p.add(next);
              count++;
              continue;
            }
            if (next.type.equals("COMMA")) {
              if (count==0) {
                param.add(new Term(p));
                p = new LinkedList();
                continue;
              }
            }
            p.add(next);
          }
          getNext();
          return new Calling(name, param);
        }
        if (next.type.equals("ASSIGN")) {
          LinkedList data=new LinkedList();
          while ((!getNext().type.equals("KEYWORD")) && (!next.type.equals("SEMICOLON"))) {
            data.add(next);
          }
          if (name.toString().equals(inFunction)) {
            return new Return(new Term(data));
          } else return new Assign(name,new Term(data));
        }
        System.out.println("Neukonceny vstup Command.read");
        return null;
      }
      if (next.code.toString().equals("begin")) {
        out=new Block();
        ((Block) out).decode();
        return out;
      }
      if (next.code.toString().equals("for")) {
        out=new For();
        ((For) out).decode();
        return out;
      }
      if (next.code.toString().equals("if")) {
        out=new If();
        ((If) out).decode();
        return out;
      }
      if (next.code.toString().equals("asm")) {
        out=new Asm();
        ((Asm) out).decode();
        return out;
      }
      if (next.code.toString().equals("repeat")) {
        out=new RepeatUntil();
        ((RepeatUntil) out).decode();
        return out;
      }
      if (next.code.toString().equals("while")) {
        out=new While();
        ((While) out).decode();
        return out;
      }
      if (next.code.toString().equals("case")) {
        out=new Case();
        ((Case) out).decode();
        return out;
      }
      if (next.code.toString().equals("with")) {
        out=new With();
        ((With) out).decode();
        return out;
      }


      System.out.println("Neukonceny vstup Command.read (2)");
      return out;
    }
  }

  class Identifier implements ToCPlusPlus {

    Identifier nextIdentifier=null;
    boolean dynamic=false,address=false;
    LEX_ident identifier=null;
    LinkedList indexsOfArray=null;
    LinkedList startIndexs=null;
    Iterator startIndexsIterator=null;

    public String toString() {
      getIdentifierType(this);
      startIndexs=startIndex;
      startIndex=new LinkedList();
      startIndexsIterator=startIndexs.iterator();

      return toString2();
    }

    private String toString2() {
      String out="";
      if (address) out+="&";
      if (identifier!=null) out+=identifier.code.toString();
      if (indexsOfArray!=null) {
        for (Iterator i=indexsOfArray.iterator();i.hasNext();)
        try{
          out += "[" + i.next().toString() + "-(" +
              startIndexsIterator.next().toString() + ")]";
        } catch (Exception e) {
          e.printStackTrace();
          stop=true;
          return out;
        }
      }
      if (nextIdentifier!=null) {
        if (nextIdentifier.identifier!=null) {
          out += dynamic ? "->" : ".";
        } else out+="[0]";
        nextIdentifier.startIndexsIterator=startIndexsIterator;
        out += nextIdentifier.toString2();
      }
      return out;
    }

    public Identifier decode() {
      if (next==null) return null;
      if (next.type.equals("IDENTIFIER")) {
          identifier=(LEX_ident) next;
          getNext();
      }
      if (next==null) return null;
      if (next.type.equals("OPEN_SQUARE_BRACKET")) {
        LinkedList l = new LinkedList();
        indexsOfArray=new LinkedList();
        int count=0;
        while ((!getNext().type.equals("CLOSE_SQUARE_BRACKET")) || (count!=0)) {
          if (next.type.equals("OPEN_SQUARE_BRACKET") || next.type.equals("OPEN_BRACKET")) count++;
          if (next.type.equals("CLOSE_SQUARE_BRACKET") || next.type.equals("CLOSE_BRACKET")) count--;
          if (next.type.equals("COMMA")) {
            if (count == 0) {
              indexsOfArray.add(new Term(l));
              l=new LinkedList();
            } else
              l.add(next);
          } else l.add(next);
        }
        indexsOfArray.add(new Term(l));
        getNext();
      }
      if (next==null) return null;
      if (next.type.equals("TERRACE_BLIND")) {
        dynamic = true;
        nextIdentifier = new Identifier();
        getNext();
        nextIdentifier.decode();
        return this;
      }
      if (next==null) return null;
      if (next.type.equals("AT-SIGN")) {
        address = true;
        nextIdentifier = new Identifier();
        getNext();
        nextIdentifier.decode();
        return this;
      }
      if (next.code.toString().equals(".")) {
        nextIdentifier = new Identifier();
        getNext();
        nextIdentifier.decode();
        return this;
      }
      return this;
    }

    public void setError() {
      if (identifier!=null) identifier.setError();
      if (nextIdentifier!=null) nextIdentifier.setError();
    }

    public void write(FileWriter out) throws Exception {
    }
  }

  class If extends Command implements ToCPlusPlus {

    Term term=null;
    Command cmd=null,cmdElse=null;

    public If() {
      type="if";
    }

    public void decode() {
      LinkedList data=new LinkedList();
      spaces.add(next);
      while (!getNext().code.toString().equals("then")) {
        data.add(next);
      }
      spaces.add(next);
      term=new Term(data);
      getNext();
      cmd=read();
      if (stop) return;
      if (next.code.toString().equals("else")) {
        spaces.add(next);
        getNext();
        cmdElse=read();
      }
      if (!next.type.equals("SEMICOLON")) {
        next.setError();
        stop=true;
        return;
      }
    }

    public void setError() {
      if (cmd!=null) cmd.setError();
      if (cmdElse!=null) cmdElse.setError();
      if (term!=null) term.setError();
    }

    public String toString() {
      spaces.start();
      return "if" + spaces.get() + "("+term.toString()+")" + spaces.get() +
         cmd.toString() + (cmd.type.equals("block")?"":((cmdElse==null)?"":";")) +
         ((cmdElse==null)?"":"else" + spaces.get() + cmdElse.toString());
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }
  }

  class For extends Command implements ToCPlusPlus {

    Assign start=null;
    int step=0;
    Term endValue=null;
    Command cmd=null;


    public For() {
      type="for";
    }

    public void decode() {
      spaces.add(next);
      getNext();
      Command c=read();
      if (!c.type.equals("assign")) {
        c.setError();
        stop=true;
        return;
      }
      start=(Assign) c;
      if (next.code.toString().equals("downto")) {
        step=-1;
      } else if (next.code.toString().equals("to")) {
        step=1;
      } else {
        next.setError();
        stop=true;
        return;
      }
      spaces.add(next);
      LinkedList data=new LinkedList();
      while (!getNext().code.toString().equals("do")) {
        data.add(next);
      }
      spaces.add(next);
      endValue=new Term(data);
      getNext();
      cmd=read();
    }

    public void setError() {
      if (start!=null) start.setError();
      if (endValue!=null) endValue.setError();
      if (cmd!=null) cmd.setError();
    }

    public String toString() {
      spaces.start();
      String out="for"+spaces.get()+"("+start.toString()+";"+start.name.toString();
      out+=(step==1)?"<=":">=";
      out+=endValue.toString()+";"+start.name.toString();
      out+=(step==1)?"++":"--";
      out+=spaces.get();
      return out+")"+spaces.get() + cmd.toString();
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }
  }

  class Assign extends Command implements ToCPlusPlus {
    Identifier name=null;
    Term term=null;

    public Assign(Identifier name, Term term) {
      type="assign";
      this.name=name;
      this.term=term;
    }

    public void setError() {
      if (name!=null) name.setError();
      if (term!=null) term.setError();
    }

    public String toString() {
      if (getIdentifierType(name)==STRING)
        switch (term.getType()) {
          case CHAR: return "sprintf(" + name + ",\"%c\"," + term.toString() + ")";
          case STRING: return "sprintf(" + name + ",\"%s\"," + term.toString() + ")";
          default:
            this.setError();
            return "";
        }
      return name.toString() + "=" + term.toString();
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }
  }

  class Return extends Command implements ToCPlusPlus {
    Term term=null;

    public Return(Term term) {
      type = "return";
      this.term = term;
    }

    public void setError() {
      if (term != null)
        term.setError();
    }

    public String toString() {
      if (term.getType()==STRING) return "return strAdd(" + term.toString() +",\"\")";
      return "return " + term.toString();
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }
  }

  class Calling extends Command implements ToCPlusPlus {

    LinkedList param=null;
    Identifier name=null;

    public Calling (Identifier name) {
      type="call";
      this.name=name;
      this.param=new LinkedList();
    }

    public Calling (Identifier name,LinkedList param) {
      type="call";
      this.name=name;
      this.param=param;
    }

    public void setError() {
      if (param!=null)
        for (Iterator i=param.iterator();i.hasNext();)
          ((LEX_default) i.next()).setError();
      name.setError();
    }

    public String toString() {
      String ident=name.toString(),out=null;

      if (ident.equals("assign")) {
          if (param.size()!=2) {
            stop=true;
            setError();
            return null;
          }
          return param.get(0).toString()+".name=" + param.get(1).toString();
      }
      if (ident.equals("reset") || ident.equals("rewrite")) {
        boolean bin=param.size()==2;
        if ((!((param.size()>0) && (param.size()<=2))) /*|| (((Term) param.get(0)).getType()!=FILE)*/) {
          stop=true;
          setError();
          return null;
        }
        return param.get(0).toString() + ".stream=fopen(" + param.get(0).toString() + ".name,\"" + (ident.equals("reset")?"r":"w") + (bin?"b":"t") + "\")";
      }
      if (ident.equals("close")) {
        if ((param.size()!=1) /*|| (((Term) param.get(0)).getType()!=FILE)*/) {
            stop=true;
            setError();
            return null;
        }
        return "fclose("+param.get(0).toString()+".stream)";
      }

      if (ident.equals("blockread") || ident.equals("blockwrite")) {
        boolean read=ident.equals("blockread");
        int count=param.size();
        if (!((read && ((count==3) || (count==4))) || ((!read) && (count==3)))) {
          stop=true;
          setError();
          return null;
        }
        /*if (
            (((Term) param.get(0)).getType()!=FILE) ||
            (((Term) param.get(1)).getType()!=ARRAY) ||
            (((Term) param.get(2)).getType()!=INTEGER) ||
            ((count==4) && (((Term) param.get(3)).getType()!=INTEGER))
        ) {
          stop=true;
          setError();
          return null;
        }*/
        out="";
        if (read && (count==4)) out+=param.get(3).toString() + "=(int)";
        return out+((read)?"fread":"fwrite") + "(&" + param.get(1) + "," + param.get(2) + ",1," + param.get(0) + ".stream)";
      }
      if (ident.equals("eof")) {
        if ((param.size()!=1) && (((Term) param.get(0)).getType()!=FILE)) {
          stop=true;
          setError();
          return null;
        }
        return "feof(" + param.get(0).toString() + ".stream)";
      }

      if (ident.equals("chr") || ident.equals("ord")) {
        if ((param.size()!=1) /* je ordina;lni && (((Term) param.get(0)).getType()!=FILE)*/) {
          stop = true;
          setError();
          return null;
        }
        return "(" + param.get(0).toString() + ")";
      }

      if (ident.equals("seek")) {
/*        if ((param.size()!=2) && (((Term) param.get(0)).getType()!=FILE) && (((Term) param.get(0)).getType()!=INTEGER)) {
          stop=true;
          setError();
          return null;
        }*/
        return "fseek(" + param.get(0).toString() + ".stream," + param.get(1).toString() + ",SEEK_SET)";
      }
      if (ident.equals("filesize")) {
/*        if ((param.size()!=2) && (((Term) param.get(0)).getType()!=FILE) && (((Term) param.get(0)).getType()!=INTEGER)) {
          stop=true;
          setError();
          return null;
        }*/
        return "((int) filesize(&" + param.get(0).toString() + "))";
      }

      if (ident.equals("write") || ident.equals("writeln") ||
          ident.equals("read") || ident.equals("readln")) {
        boolean ln;
        if (ident.equals("write") || ident.equals("writeln")) out = "printf(";
        if (ident.equals("read") || ident.equals("readln")) out = "scanf(";
        ln=ident.equals("writeln") /*|| ident.equals("readln")*/;
        String pom="";
        boolean read=(ident.equals("read") || ident.equals("readln"));
//        if (param.size()==2){
//          System.out.print("a");
//        };
        LinkedList param2=(LinkedList) param.clone();
        if (param.size()>0)
          if (((Term) param.get(0)).getType() == FILE) {
            out="f"+out+((Term) param.get(0)).toString()+".stream,";
            param2.removeFirst();
          }
        out+="\"";

        for (Iterator i=param2.iterator();i.hasNext();) {
          Term term=(Term) i.next();
          switch (term.getType()) {
            case INTEGER: case WORD: case SHORTINT: case BYTE: case LONGINT:
              pom+=(read?"&":"")+term.toString();
              out+="%d";
              break;
            case REAL: case DOUBLE: case SINGLE: case COMP:
              pom+=(read?"&":"")+term.toString();
              out+="%d";
              break;
            case CHAR:
              pom+=(read?"&":"")+term.toString();
              out+="%c";
              break;
            case STRING:
              pom+=term.toString();
              out+="%s";
              break;
            case BOOLEAN:
              pom += "(" + term.toString() + ")?:\"true\":\"false\"";
              out += "%s";
              break;
            default:
              //for (Iterator it=varLocal.iterator();it.hasNext();)
              //  System.out.print(it.next().toString() + " || ");
              //System.out.println();
              //this.setError();
          }
          if (i.hasNext()) pom+=",";
        }
        if (ln) {
          out += "\\n";
        } else if (read && pom.length()==0) out+=" ";
        out+="\"" + ((pom.length()==0)?"":",") + pom + ")";
        return out;
      }

      if (ident.equals("inc")) {
        switch (param.size()) {
          case 1: return ((Term) param.get(0)).toString()+"++";
          case 2: return ((Term) param.get(0)).toString()+"+="+((Term) param.get(1)).toString();
          default:
            this.setError();
            return null;
        }
      }

      if (ident.equals("dec")) {
        switch (param.size()) {
          case 1: return ((Term) param.get(0)).toString()+"--";
          case 2: return ((Term) param.get(0)).toString()+"-="+((Term) param.get(1)).toString();
          default:
            this.setError();
            return null;
        }
      }

      if (ident.equals("sizeof"))
        if (param.size()==1) {
          return "((short) sizeof(" + param.get(0) + "))";
        } /*else {
          setError();
          stop=true;
          return;
        }*/

     if (ident.equals("length"))
        if (param.size()==1) {
          return "((short) strlen(" + param.get(0) + "))";
        } /*else {
          setError();
          stop=true;
          return;
        }*/

     if (ident.equals("halt"))
       if (param.size() == 1) {
         return "exit(" + param.get(0) + ")";
       }
       /*else {
           setError();
           stop=true;
           return;
         }*/


     if (ident.equals("new"))
        if (param.size()==1) {
          String o=param.get(0).toString() + "=(";
          VarValue vv=getVarValue(((Term) param.get(0)).getFirstIdentifier());
          String vvs=vv.type.toString();
          o+=vvs+") new(" +vvs.substring(0,vvs.length()-1)+")";
          return o;
          //+ (short) strlen(" + param.get(0) + "))";
        } /*else {
          setError();
          stop=true;
          return;
        }*/


      out=ident+"(";
      if (param!=null)
        for (Iterator i=param.iterator();i.hasNext();)
          out+=i.next().toString() + (i.hasNext()?",":"");
      return out + ")";
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }
  }

  class Block extends Command implements ToCPlusPlus {

    LinkedList list=new LinkedList();

    public Block() {
      type="block";
    }

    public void decode() {
      if (!next.code.toString().equals("begin")) {
        next.setError();
        stop=true;
        return;
      }
      spaces.add(next);
      while (!getNext().code.toString().equals("end")) {
        list.add(read());
        if (stop) {
          return;
        }
        if (!next.type.equals("SEMICOLON")) {
          next.setError();
          stop=true;
          return;
        }
        spaces.add(next);
      }
      spaces.add(next);
      getNext();
    }

    public void setError() {
      if (list!=null)
        for (Iterator i=list.iterator();i.hasNext();)
          ((LEX_default) i.next()).setError();
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      spaces.start();
      String out="{"+spaces.get();
      if (list!=null)
        for (Iterator i=list.iterator();i.hasNext();) {
          Object o=i.next();
          if (o!=null) out += o.toString() + ";"+spaces.get();
        }
      return out+"}"+spaces.get();
    }
  }

  class While extends Command implements ToCPlusPlus {

    Term term=null;
    Command cmd=null;

    public While() {
      type="while";
    }

    public void decode() {
      LinkedList l=new LinkedList();
      spaces.add(next);
      while (!getNext().code.toString().equals("do"))
        l.add(next);
      spaces.add(next);
      term=new Term(l);
      getNext();
      cmd=read();
    }

    public void setError() {
    }

    public String toString() {
      spaces.start();
      String out="while" + spaces.get() + "(" + term.toString() + ")" +
          spaces.get() + cmd.toString();
      return out;
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }
  }

  class RepeatUntil extends Block implements ToCPlusPlus {

    Term term=null;
    SpacesManager spaces=new SpacesManager();

    public RepeatUntil() {
      type="repeatuntil";
    }

    public void decode() {

      do {
        super.spaces.add(next);
        getNext();
        if (next.code.toString().equals("until")) {
          break;
        }
        Command c=read();
        super.spaces.add(next);
        list.add(c);
      } while (true);
      spaces.add(next);
      LinkedList l=new LinkedList();
      while (!getNext().type.equals("SEMICOLON"))
        l.add(next);
      term=new Term(l);
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      spaces.start();
      String out="do";
      out+=super.toString();
      return out+"while" + spaces.get() + "(!(" + term.toString()+"))";
    }
  }

  class CasePart extends Command implements ToCPlusPlus {

    LinkedList value=null;
    Command command=null;

    public CasePart() {
      type="case-part";
    }
    public void decode() {
      if (!next.code.toString().equals("else")) {
        value = new LinkedList();
        do {
          LEX_default lex = null;
          if (next.type.equals("STRING"))
            lex = next;
          if (isNumber())
            lex = next;
          if (next.type.equals("IDENTIFIER"))
            lex = next; //a zaroven je to konstanta!!!
          if (lex == null) {
            next.setError();
            stop = true;
            return;
          }
          value.add(next);
          if (getNext().type.equals("COLON"))
            break;
          if (!next.type.equals("COMMA")) {
            next.setError();
            stop = true;
            return;
          }
          getNext();
        }
        while (true);
        spaces.add(next);
      } else {
        spaces.add(next);
      }
      getNext();
      command=read();
      spaces.add(next);
    }
    public String toString() {
      String out="";
      spaces.start();
      if (value!=null) {
        for (Iterator i = value.iterator(); i.hasNext(); )
          out += "case " + i.next().toString() + ":" + spaces.get();
      } else out+="default:" + spaces.get();
      return out+command.toString()+"; break;" + spaces.get();//"; continue;";
    }
    public void setError() {
    }

    public void write(FileWriter out) {
    }
  }

  class Case extends Command implements ToCPlusPlus {

    LinkedList list=new LinkedList();
    Term term=null;

    public Case() {
      type="case";
    }
    public void decode() {
      LinkedList l=new LinkedList();
      spaces.add(next);
      while (!getNext().code.toString().equals("of"))
        l.add(next);
      spaces.add(next);
      term=new Term(l);
      while (!getNext().code.toString().equals("end")) {
        CasePart cp=new CasePart();
        cp.decode();
        list.add(cp);
      }
      if (!getNext().type.equals("SEMICOLON")) {
        next.setError();
        stop=true;
        return;
      }
    }

    public String toString() {
      spaces.start();
      String out="switch" + spaces.get() + "(" + term.toString() + ") {" + spaces.get();
      if (list!=null)
        for (Iterator i=list.iterator();i.hasNext();)
          out+=i.next().toString();
      return out+"}";
    }
    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public void setError() {
    }
  }

  class Asm extends Command implements ToCPlusPlus {

    LinkedList data=new LinkedList();

    public void decode() {
      while (!getNext().code.toString().equals("end"))
        data.add(next);
      if (!getNext().type.equals("SEMICOLON")) {
        next.setError();
        stop=true;
        return;
      }
    }

    public void setError() {
    }

    public String toString() {
      String out="asm {";
      for (Iterator i=data.iterator();i.hasNext();) {
        LEX_default lex=(LEX_default) i.next();
        out += lex.code.toString();
        if (lex.follow!=null)
          for (Iterator j=lex.follow.iterator();j.hasNext();)
            out+=j.next().toString();
      }
      return out + "}";
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }
  }

  class With extends Command implements ToCPlusPlus {

    Identifier begin=new Identifier();
    Command cmd=null;

    public With() {
      type="with";
    }

    public void decode() {
      getNext();
      begin.decode();
      if (!next.code.toString().equals("do")) {
        next.setError();
        stop=true;
        return;
      }
      getNext();
      cmd=read();
    }

    public void setError() {
    }

    public void write(FileWriter out) {
    }
  }

  class Term implements ToCPlusPlus {

    TermNode node = null;
    SpacesManager spaces=new SpacesManager();

    private final String table[][][] = {
    {
      {"<"  ,"<" ,"<" },
      {">"  ,">" ,">" },
      {"="  ,"==","=="},
      {">=" ,">=",">="},
      {"<=" ,"<=","<="},
      {"<>" ,"!=","!="},
      {"in" ,null,null}
    },{
      {"+"  ,"+" ,"+" },
      {"-"  ,"-" ,"-" },
      {"or" ,"|" ,"||"},
      {"xor","^" ,"^^"}
   },{
      {"*"  ,"*" ,"*" },
      {"/"  ,"*1.0/","*1.0/"},
      {"div","/" ,"/" },
      {"mod","%" ,"%" },
      {"and","&" ,"&&"},
      {"shl","<<","<<"},
      {"shr",">>",">>"}
    },{
      {"-"  ,"-" ,"-" },
      {"+"  ,"+" ,"+" },
      {"@"  ,"&" ,"&" },
      {"not","~" ,"!" }
    }};

    LinkedList data = null;
    LinkedList stack = new LinkedList();
    Iterator termIterator = null;
    LEX_default termNext = null;
    int termIteratorCount = 0;
    boolean stop = false;

    public int getIntValue() {
      return ((TermNode) stack.get(0)).getIntValue();
    }

    public Term(LinkedList data) {

      this.data = data;
      this.termIterator = data.iterator();
      try {
        getNext();
        t();
        if (stack.size()>1) ((TermNode) stack.get(2)).setError();
        if (stack.size()==0) {
          stop=true;
          System.out.println("Chyba pri prekladu vyrazu");
          return;
        }
      }
      catch (Exception e) {
        e.printStackTrace();
        System.exit(0);
      }
    }

    public Identifier getFirstIdentifier() {
      return ((TermNode) stack.getFirst()).getFirstIdentifier();
    }

    public int getType() {
      if (stack.size()==0) return ERROR;
      return ((TermNode)stack.getFirst()).getType();
    }

    public void setError() {
      if (stack.size()>0) ((TermNode) stack.getFirst()).setError();
    }

    private LEX_default getNext() {
      if (!termIterator.hasNext()) {
        return termNext = null;
      }
      termIteratorCount++;
      return termNext = (LEX_default) termIterator.next();
    }

    private String[] rule(int index) {
      if (termNext == null)
        return null;
      for (int i = 0; i < table[index].length; i++)
        if (table[index][i][0].equals(termNext.code.toString()))
          return table[index][i];
      return null;
    }

    private void t() {
      b();
      a();
    }

    private void a() {
      if (termNext==null) return;
      if (termNext.code.toString().equals("in")) {
        new In();
        a();
        return;
      }
      String[] data = rule(0);
      if (data != null) {
        getNext();
        b();
        new BinaryOperation(data);
        a();
      }
    }

    private void b() {
      d();
      c();
    }

    private void c() {
      String[] data = rule(1);
      if (data != null) {
        getNext();
        d();
        new BinaryOperation(data);
        c();
      }
    }

    private void d() {
      f();
      e();
    }

    private void e() {
      String[] data = rule(2);
      if (data != null) {
        getNext();
        f();
        new BinaryOperation(data);
        e();
      }
    }

    private void f() {
      String[] data = rule(3);
      if (data != null) {
        getNext();
        g();
        new UnaryOperation(data);
      }
      else
        g();
    }

    private void g() {
      if (termNext==null) return;

      if (termNext.type.equals("TYPE")) {
        LEX_default type=termNext;
        if (!getNext().type.equals("OPEN_BRACKET")) {
          termNext.setError();
          stop=true;
          return;
        }
        getNext();
        t();
        if (!termNext.type.equals("CLOSE_BRACKET")) {
          termNext.setError();
          stop=true;
          return;
        }
        getNext();
        new Retype(type);
        return;
      }
      if (termNext.type.equals("OPEN_BRACKET")) {
        getNext();
        t();
        if (!termNext.type.equals("CLOSE_BRACKET")) {
          termNext.setError();
          stop = true;
          return;
        }
        getNext();
        return;
      }
      if (termNext.type.equals("IDENTIFIER")) {
        LEX_default n=next;
        Iterator i=iterator;
        int ic=iteratorCount;
        boolean gnw=getNextWriter;
        next=termNext;
        iterator=termIterator;
        iteratorCount=termIteratorCount;
        getNextWriter=false;

        Identifier ident=new Identifier();
        ident.decode();
        getNextWriter=gnw;
        termNext=next;
        termIterator=iterator;
        termIteratorCount=iteratorCount;
        next=n;
        iterator=i;
        iteratorCount=ic;

        boolean x;
        if (termNext==null) {
          x=true;
        } else {
          x=!termNext.type.equals("OPEN_BRACKET");
        }
        if (x) {
          if (isSubprogram(ident)) {
            new Value(new Calling(ident, new LinkedList()));
            return;
          }
          new Value(ident);
          if ((termNext!=null)&&(termNext.type.equals("COLON"))) {
            new Format();
            return;
          }
          return;
        }

        if (termNext.type.equals("OPEN_BRACKET")) {
          LinkedList param=new LinkedList();
          LinkedList p=new LinkedList();
          int count=0;
          while (true) {
            getNext();
            if (termNext.type.equals("OPEN_BRACKET") || termNext.type.equals("OPEN_SQUARE_BRACKET")) {
              p.add(termNext);
              count++;
              continue;
            }
            if (termNext.type.equals("CLOSE_BRACKET") || termNext.type.equals("CLOSE_SQUARE_BRACKET")) {
              if (count==0) {
                param.add(new Term(p));
                break;
              }
              p.add(termNext);
              count--;
              continue;
            }
            if (termNext.type.equals("COMMA")) {
              if (count==0) {
                param.add(new Term(p));
                p = new LinkedList();
                continue;
              }
            }
            p.add(termNext);
          }
          new Value(new Calling(ident,param));
          getNext();
        }
        return;
      }
      new Value(termNext);
      getNext();
      if ((termNext!=null)&&(termNext.type.equals("COLON"))) {
        new Format();
        return;
      }
    }

    public void write(FileWriter out) throws Exception {
      out.write(toString());
    }

    public String toString() {
      if (stack.size() == 0)
        return "";
      String out=((TermNode) stack.get(0)).toString();
      if ((out.charAt(0)=='(') && (out.charAt(out.length()-1)==')')) {
          return out.substring(1,out.length()-1);
      } else return out;
    }

    abstract class TermNode {
      TermNode terms[];
      String rule[];
      boolean binary=false;

      abstract int getType();
      abstract Identifier getFirstIdentifier();
      abstract int getIntValue();
      abstract void setError();

      int countOfNodes = 0;
    }

    class Format extends TermNode {
      Term fconst[]={null,null};
      TermNode term=null;

      public Format() {
        term=(TermNode) stack.getLast();
        stack.removeLast();
        LinkedList l=new LinkedList();
        while (!((getNext()==null) || termNext.type.equals("COLON") || termNext.type.equals("CLOSE_BRACKET")))
          l.add(termNext);
        fconst[0]=new Term(l);
        if ((term.getType()&0xF0)==0x20) {
          if (termNext.equals("COLON")) {
              l=new LinkedList();
              while (!((getNext()!=null) || termNext.type.equals("COLON") || termNext.type.equals("CLOSE_BRACKET")))
                l.add(termNext);
              fconst[1]=new Term(l);
          }
        }
        stack.add(this);
      }

      int getType() {
        return STRING;
      }

      Identifier getFirstIdentifier() {
        Identifier i;
        i=fconst[0].getFirstIdentifier();
        if (i!=null) return i;
        if (fconst[1]!=null) return fconst[1].getFirstIdentifier();
        return null;
      }

      int getIntValue() {
        return Integer.MIN_VALUE;
      }

      public String toString() {
        return "format("+term.toString()+","+fconst[0].toString()+
            ((fconst[1]==null)?")":","+fconst[1].toString()+")");
      }

      void setError() {
        if (term!=null) term.setError();
        for (int i=0;i<2;i++)
          if (fconst[i]!=null) fconst[i].setError();
      }
    }

    class Retype extends TermNode {
      LEX_default type=null;
      TermNode term=null;

      public Retype(LEX_default type) {
        this.type=type;
        term=(TermNode) stack.getLast();
        stack.removeLast();
        stack.addLast(this);
      }

      public Identifier getFirstIdentifier() {
        return term.getFirstIdentifier();
      }

      int getType() {
        for (int i=1;i<types[0].length;i++)
          if (type.code.toString().equals(types[0][i]))
            return i;
        return ERROR;
      }

      public String toString() {
        return "((" + types[1][getType()] + ")" + term.toString() + ")";
      }

      int getIntValue() {
        return terms[0].getIntValue();
      }

      void setError() {
        type.setError();
        term.setError();
      }
    }

    class UnaryOperation extends TermNode {
      public UnaryOperation(String[] rule) {
        countOfNodes = 1;
        terms = new TermNode[1];
        terms[0] = (TermNode) stack.getLast();
        stack.removeLast();
        stack.add(this);
        this.rule = rule;
      }

      public Identifier getFirstIdentifier() {
        return terms[0].getFirstIdentifier();
      }

      int getType() {
        int t=terms[0].getType();
        if (rule[0].equals("+") || rule[0].equals("-")) return t;
        if (rule[0].equals("not")) {
          if (t==BOOLEAN) {
            binary=false;
          } else {
            binary=true;
          }
          return t;
        }
        return ERROR; // @
      };

      public String toString() {
        return "(" + rule[terms[0].getType()==BOOLEAN?2:1] + terms[0].toString() + ")";
      }

      int getIntValue() {
        if (rule[0].equals("+")) return terms[0].getIntValue();
        if (rule[0].equals("-")) return -terms[0].getIntValue();
        if (rule[0].equals("NOT")) return ~terms[0].getIntValue();
        return Integer.MIN_VALUE;
      }

      void setError() {
        terms[0].setError();
      }
    }

    class BinaryOperation extends TermNode {
      public BinaryOperation(String[] rule) {
        countOfNodes = 2;
        terms = new TermNode[2];
        for (int i = 0; i < 2; i++) {
          terms[1 - i] = (TermNode) stack.getLast();
          stack.removeLast();
        }
        stack.add(this);
        this.rule = rule;
      }

      public Identifier getFirstIdentifier() {
        Identifier i=terms[0].getFirstIdentifier();
        if (i==null) return terms[1].getFirstIdentifier();
        return i;
      }


      int getType() {
        int t1=terms[0].getType(),t2=terms[1].getType();
        if (((t1&0xf0) == 2) && ((t2&0xf0) == 1)) return t1;
        if (((t1&0xf0) == 1) && ((t2&0xf0) == 2)) return t2;
        if ((t1&0xf0) != (t2&0xf0)) return ERROR;
        if (t1==BOOLEAN) {
          binary=false;
          return BOOLEAN;
        } else {
          if (rule[0].equals("=") || rule[0].equals("<>") ||
              rule[0].equals("<") || rule[0].equals(">")) {
            binary=true;
            return BOOLEAN;
          }
          binary=true;
          if ((t1&0xF0)==0x30) return STRING;
          return (t1>t2)?t1:t2;
        }
      }

      public String toString() {
        if ((terms[0].getType()&0xf0)==0x30) {
          if (rule[0].equals("+")) {
            return "(strAdd(" + terms[0].toString() + "," + terms[1].toString() + "))";
          } else {
            if (rule[0].equals("=")) {
              return "(equalStrings(" + terms[0].toString() + "," + terms[1].toString() + "))";
            }
            if ((terms[0].getType()!=CHAR) || (terms[1].getType()!=CHAR)) {
              setError();
              stop = true;
            }
          }
        }
        return "(" + terms[0].toString() + rule[binary?1:2] + terms[1].toString() + ")";
      }

      int getIntValue() {
        if (rule[0].equals("+")) return terms[0].getIntValue()+terms[1].getIntValue();
        if (rule[0].equals("-")) return terms[0].getIntValue()-terms[1].getIntValue();
        if (rule[0].equals("AND")) return terms[0].getIntValue()&terms[1].getIntValue();
        if (rule[0].equals("XOR")) return terms[0].getIntValue()^terms[1].getIntValue();
        if (rule[0].equals("OR")) return terms[0].getIntValue()|terms[1].getIntValue();
        return Integer.MIN_VALUE;
      }

      void setError() {
        if (terms[0]!=null) terms[0].setError();
        if (terms[0]!=null) terms[1].setError();
      }
    }

    class In extends TermNode {
      TermNode term=null;
      LinkedList data=new LinkedList();

      public In() {
        term=(TermNode) stack.getLast();
        stack.removeLast();
        stack.add(this);
        if (!getNext().type.equals("OPEN_SQUARE_BRACKET")) {
          stop=true;
          setError();
          return;
        }
        getNext();
        while (true) {
          if (termNext.type.equals("CLOSE_SQUARE_BRACKET")) break;

          LinkedList l=new LinkedList();
          int count=0;
          while ((!(termNext.type.equals("TO") || termNext.type.equals("CLOSE_SQUARE_BRACKET") || termNext.type.equals("COMMA"))) || (count>0)) {
            l.add(termNext);
            if (termNext.type.equals("OPEN_BRACKET") || termNext.type.equals("OPEN_SQUARE_BRACKET")) count++;
            if (termNext.type.equals("CLOSE_BRACKET") || termNext.type.equals("CLOSE_SQUARE_BRACKET")) count--;
            getNext();
          }
          data.add(new Term(l));

          if (termNext.type.equals("TO")) {
            l=new LinkedList();
            count=0;
            while ((!(getNext().type.equals("CLOSE_SQUARE_BRACKET") || termNext.type.equals("COMMA"))) || (count>0)) {
              l.add(termNext);
              if (termNext.type.equals("OPEN_BRACKET") || termNext.type.equals("OPEN_SQUARE_BRACKET")) count++;
              if (termNext.type.equals("CLOSE_BRACKET") || termNext.type.equals("CLOSE_SQUARE_BRACKET")) count--;
            }
            data.add(new Term(l));
            //data.add(new Value(getNext()));
            Interval i=new Interval();
            i.lim[1]=(Term) data.getLast();
            data.removeLast();
            i.lim[0]=(Term) data.getLast();
            data.removeLast();
            data.add(i);
            //getNext();
          }
          if (termNext.type.equals("COMMA")) {
            getNext();
            continue;
          }

          if (!termNext.type.equals("CLOSE_SQUARE_BRACKET")) {
            setError();
            stop=true;
            return;
          }
        }
        getNext();
      }

      public Identifier getFirstIdentifier() {
        return null;
      }

      public String toString() {
        String out="(";
        for (Iterator i=data.iterator();i.hasNext();)
          out+="in("+term.toString()+","+i.next().toString()+")"+(i.hasNext()?"||":")");
        return out;
      }

      class Interval {
        Term lim[]=new Term[2];
        public String toString() {
          return lim[0].toString()+","+lim[1].toString();
        }

        public void setError() {
          if (lim[0]!=null) lim[0].setError();
          if (lim[1]!=null) lim[1].setError();
        }
      }

      int getType() {
        return BOOLEAN;
      }

      int getIntValue() {
        return Integer.MIN_VALUE;
      }

      void setError() {
        if (term!=null) term.setError();
        for (Iterator i=data.iterator();i.hasNext();) {
          try {
            ( (Term) i.next()).setError();
          } catch (Exception e) {
            ( (Interval) i.next()).setError();
          }
        }
      }
    }

    class Value extends TermNode {
      LEX_default lex=null;
      Identifier identifier=null;
      Calling calling=null;

      public void setError() {
        if (lex!=null) lex.setError();
        if (identifier!=null) identifier.setError();
        if (calling!=null) calling.setError();
      }

      public Value(LEX_default lex) {
        this.lex = lex;
        stack.add(this);
      }

      public Value(Identifier ident) {
        this.identifier=ident;
        stack.add(this);
      }

      public Value(Calling calling) {
        this.calling=calling;
        stack.add(this);
      }

      public Identifier getFirstIdentifier() {
        return identifier;
      }

      int getType() {
        if (identifier!=null) {
          //if (identifier.address) return POINTER;
          //yde musi bejt dekodovani libovlnzho identifikatoru
//          System.out.println("<"+identifier.toString()+">");
          return getIdentifierType(identifier);
        }
        if (calling!=null) {
          //if (identifier.address) return POINTER;
          //yde musi bejt dekodovani libovlnzho identifikatoru
//          System.out.println("<"+identifier.toString()+">");
          return getIdentifierType(calling.name);
        }

        if (lex!=null) {
          if (lex.code.toString().equals("file")) return FILE;
          if (lex.type.equals("STRING")) return ((LEX_string) lex).getType();
          if (lex.type.equals("NUMBER [CHAR]")) return CHAR;
          if (lex.type.equals("NUMBER [BOOL]")) return BOOLEAN;
          if (lex.type.equals("NUMBER [FLOAT]")) return REAL; //vetveni?
          if (lex.type.equals("NUMBER [INT HEX]") ||
              lex.type.equals("NUMBER [INT DEC]")) {
            long v=((LEX_number) lex).getIntValue();
            if (v>=0) {
              if (v<(1<<8)) return BYTE;
              if (v<(1<<16)) return WORD;
              if (v<(1<<32)) return LONGINT;
            } else {
              if (v>-(1<<7)) return SHORTINT;
              if (v>-(1<<15)) return INTEGER;
              if (v>-(1<<31)) return LONGINT;
            }
            return ERROR;
          }
        }
        //System.out.println(this.toString());
        return ERROR; //detekce promennych, fci ap.
      }

      public String toString() {
        if (calling!=null) return calling.toString();
        if (identifier!=null) return identifier.toString();
        if (lex!=null) return lex.toString();
        return "";
      }

      int getIntValue() {
        if (lex!=null) return ((LEX_number) lex).getIntValue();
        if (identifier!=null) {
          String name=identifier.toString();
          for (Iterator i=constant.data.iterator();i.hasNext();) {
            ConstantData cd=(ConstantData) i.next();
            if (cd.name.toString().equals(name))
              return Integer.parseInt(cd.value.lex.toString());
          }
        }
        return Integer.MIN_VALUE;
      }

    }
  }

}